/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('AppCtrl', MainController);

  function MainController($scope, $rootScope, LoginFactory, warningForm
    , $httpFactory, $state, $ionicPopup, $ionicPlatform, $cordovaAppVersion, localStorageService, $ionicLoading) {

    {
      console.time("AppCtrl");
      initApp();    //初始化本地记录

      //$scope.isLogin = appv.currentUser ? true : false;
      $scope.toUserInfo = toUserInfo;
      $scope.toShop = toShop;
      $scope.gotoSetting = gotoSetting;

      LoginFactory.initLoginModal($rootScope);

      //选择教材
      $scope.chooseBook = chooseBook;
      $scope.toBook = toBook;

      // 签到
      // $scope.everyDaySign = everyDaySign;

      //软件推荐
      $scope.recommend = recommend;

      /* 分享软件 */
      $scope.shareApp = shareApp;

      $scope.dialog_aat = dialog_aat;
      /* 自动化测试 */

      //填写邀请码
      $scope.bindInviteCode = bindInviteCode;
      $scope.save = save;
      $scope.invite = {
        code: null
      };

      //活动中心
      $scope.toActivity = toActivity;
      //我的消息
      $scope.toMessage = toMessage;
      //财富榜
      $scope.toRichList = toRichList;
      //一键加群
      $scope.joinQQGroup = joinQQGroup;
      //用户反馈
      $scope.feedback = feedback;
      //关于软件
      $scope.about = about;
      /* 清空缓存 */
      $scope.clearAllCache = clearAllCache;

      onLoaded();
      checkWebViewCache();// 检查Webview缓存是否需要更新

      console.timeEnd("AppCtrl");
      console.timeEnd("App state");
    }

    function onLoaded() {
      $scope.$watch('$viewContentLoaded', function () {
        console.timeEnd('App page load');
      });
    }

    /**
     * 签到
     */
    // function everyDaySign() {
    //   // {"curRec":1,"message":"签到成功","object":{"addGold":1},"result":0,"totalRec":1}
    //   $httpFactory.everyDaySign();
    // }

    /**
     * app初始化
     */
    function initApp() {
      if (localStorageService.get('token')) {
        appv.token = localStorageService.get('token');
        $httpFactory.setToken(localStorageService.get('token'));

        if (localStorageService.get('currentUser')) {
          appv.currentUser = localStorageService.get('currentUser');
        }
        if (localStorageService.get('bookGold')) {
          appv.bookGold = localStorageService.get('bookGold');
        }
      }
    }

    /**
     * 检查Webview缓存是否需要更新
     */
    function checkWebViewCache() {
      var webViewCacheVersionClient = localStorageService.get('webViewCacheVersionClient');
      !webViewCacheVersionClient && localStorageService.set('webViewCacheVersionClient', +new Date());// 初始化WebView缓存的数据时间

      $httpFactory.getSysConfig_1801('webViewCache-Version').then(function (res) {
        if (res.data && res.data.object) {
          var webViewCacheVersionServer = res.data.object.list[0].value;
          if (webViewCacheVersionServer > webViewCacheVersionClient) {
            var iab = window.open();
            iab && iab.clearAllCache && iab.clearAllCache();
            localStorageService.set('webViewCacheVersionClient', +new Date());// 刷新本地WebView缓存的数据时间
          }
        }
      });
    }

    function toUserInfo() {
      if (!appv.currentUser) {
        $scope.login();
      } else {
        $state.go('app.userInfo');
      }
    }

    function toShop() {
      warningForm(null, '暂未开放')
    }

    function gotoSetting() {
      $state.go('app.setting');
    }

    //选择教材
    function chooseBook() {
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'chooseBook',
        templateUrl: 'app/app/chooseBook.html',
        scope: $scope
      });
    }

    /** 软件推荐 */
    function recommend() {
      if ($scope.redInfo && $scope.redInfo.newRecommend) {
        var data = {
          content: JSON.stringify({
            newRecommend: false
          })
        };
        updateRedInfo(data);
      }
      ;
      $state.go('app.recommend_list');
    }

    /*帮助反馈*/
    function feedback() {
      if ($scope.redInfo && $scope.redInfo.newFeedback) {
        var data = {
          content: JSON.stringify({
            newFeedback: false
          })
        };
        updateRedInfo(data);
      }
      ;
      my.log("帮助反馈");
      $state.go('app.feedback');
    }

    /*关于赛学霸物理*/
    function about() {
      my.log("关于赛学霸物理");
      $state.go('app.about')
    }

    function toBook(bookVersion) {
      // window.localStorage.setItem("bookVersion", bookVersion);
      localStorageService.set("bookVersion", bookVersion);
      $scope.myPopup.close();
      //$state.go('app.home');
    }

    /**
     * 分享软件
     */
    function shareApp() {
      $httpFactory.sys.config('shareApp').then(function (response) {
        shareApp_handle(response);
      })
    }

    function shareApp_handle(response) {

      // 示例
      // $scope.share_static =
      // {
      //   items: [
      //     {imgSrc: 'img/icon/qzone.png', name: 'Qzone', goldNum: 5},
      //     {imgSrc: 'img/icon/wechatTimeline.png', name: 'wechatTimeline', goldNum: 5},
      //     //{imgSrc: 'img/icon/weibo.png', name: 'weibo', goldNum: 5},
      //     //{imgSrc: 'img/icon/qq.min.png', name: 'qq', goldNum: 1},
      //     {imgSrc: 'img/icon/wechat.min.png', name: 'wechat', goldNum: 1}
      //   ],
      //   params: {
      //     title: 'title',
      //     description: 'description',
      //     thumb: 'https://cordova.apache.org/images/cordova_256.png',
      //     url: 'http://wuli.saixueba.com/wosaiIntro/download.html'
      //   },
      //   remark: '成功邀请好友,即可得20倍金币奖励'
      // };

      $scope.share = JSON.parse(response.data.object[0].value);
      $scope.share.inviteCode = appv.currentUser && appv.currentUser.inviteCode;
      $scope.share.params.title = $scope.share.params.title.replace('{{inviteCode}}', $scope.share.inviteCode);
      $scope.share.params.description = $scope.share.params.description.replace('{{inviteCode}}', $scope.share.inviteCode);
      // $scope.share.remark = $scope.share.remark.replace('{{inviteCode}}',$scope.share.inviteCode);

      for (var i in $scope.share.items) {
        f_isInstall($scope.share.items[i]);
      }

      setTimeout(function () {$scope.$apply();},200);// 脏检查

      $scope.f_share = f_share;// 分享
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/shareApp.html',
        scope: $scope
      });

      function f_isInstall(item) {
        if (_app.isWeb) {
          item.isInstall = 1;
          return;
        }

        switch (item.name) {
          case 'Qzone':
            $scope.isInstall_qq().then(success, fail);
            return true;
          case 'wechatTimeline':
            $scope.isInstall_wechat().then(success, fail);
            return true;
          case 'weibo':
            $scope.isInstall_weibo().then(success, fail);
            return true;
          case 'qq':
            $scope.isInstall_qq().then(success, fail);
            return true;
          case 'wechat':
            $scope.isInstall_wechat().then(success, fail);
            return true;
        }
        function success(response) {
          item.isInstall = response;
          // $scope.$apply();
        }

        function fail(failResponse) {
          console.log(failResponse);
          // $scope.$apply();
        }
      }

      function f_share(item, params) {
        // var params = [params.title, params.description, params.thumb, params.url];
        switch (item.name) {
          case 'Qzone':
            $rootScope.share_Qzone(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'wechatTimeline':
            $rootScope.share_wechatTimeLine(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'weibo':
            $rootScope.share_weibo(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'qq':
            $rootScope.share_qq(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'wechat':
            $rootScope.share_wechat(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
        }

        function success(response) {
          console.log('分享成功', response);
        }

        function fail(failResponse) {
          console.log('分享失败', failResponse);
        }
      }
    }

    function dialog_aat() {
      $scope.aat = window.aat;
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/dialog_aat.html',
        scope: $scope
      });

      $scope.aat_action = function (item) {
        item.action();
      }
    }

    //填写邀请码
    function bindInviteCode() {
      // 一个精心制作的自定义弹窗
      if (!appv.currentUser && !appv.token) {
        $rootScope.login();
        return;
      }
      if ($scope.userInfo.friendInviteCode) {
        $scope.invite.code = $scope.userInfo.friendInviteCode;
      }
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/invite.html',
        scope: $scope
      });
    }

    function save() {
      if ($scope.userInfo.friendInviteCode) {
        $scope.myPopup.close();
        return;
      } else if (!$scope.invite.code || $scope.invite.code.length <= 0) {
        $ionicLoading.show({template: '请输入正确的邀请码'})
      }

      else {
        $httpFactory.activity.bindInvite($scope.invite.code).then(function (res) {
          if (res.data.result == 0) {
            //appv.currentUser.friendInviteCode = $scope.invite.code;
            $scope.userInfo.friendInviteCode = $scope.invite.code;
            warningForm(null, res.data.message);
            $scope.myPopup.close();
          } else {
            warningForm(null, res.data.message);
          }
        });
      }
    }

    function updateRedInfo(data) {
      $httpFactory.user.redInfoRead(data).then(function (res) {
        if (res.data.result == 0) {
          $scope.redInfo = res.data.object;
        }
        else {
          console.log(res.data.message);
        }
      })
    }

    //活动中心
    function toActivity() {
      if ($scope.redInfo && $scope.redInfo.newActity) {
        var data = {
          content: JSON.stringify({
            newActity: false
          })
        };
        updateRedInfo(data);
      }
      ;
      $state.go('app.activity');
    }

    //我的消息
    function toMessage() {
      if ($scope.redInfo && $scope.redInfo.newMessage) {
        var data = {
          content: JSON.stringify({
            newMessage: false
          })
        };
        updateRedInfo(data);
      }
      $state.go('app.message');
    }

    //财富榜
    function toRichList() {
      $state.go('app.rich');
    }

    //一键加群
    function joinQQGroup() {
      var key = 'joinQQGroup';
      $httpFactory.getSysConfig_1801(key).then(function (res) {
        if (res.data.result == 0) {
          var joinQQGroupJson = JSON.parse(res.data.object.list[0].value)
          if (_app.isAndroid) {
            JoinQQGroup.open({key: joinQQGroupJson.android.key});
          } else if (_app.isIos) {
            JoinQQGroup.open({uin: joinQQGroupJson.ios.uin, key: joinQQGroupJson.ios.key});
          }
        }
      });
    }

    function clearAllCache() {
      var iab = window.open();
      iab.clearAllCache && iab.clearAllCache();
    }
  }
})();
