
# 要求
- android4.4.4+ 使用了new Promise()

`谈谈 ES6 的 Promise 对象 - ac黄博客精选 - SegmentFault`
https://segmentfault.com/a/1190000002928371
![](https://sfault-image.b0.upaiyun.com/219/851/2198519534-55896290241aa_articlex)

---

# 微信登录API说明
https://open.weixin.qq.com/cgi-bin/showdocument?action=dir_list&t=resource/res_list&verify=1&id=open1419317851&token=&lang=zh_CN

- 第一步:请求CODE - 移动应用微信授权登录
- 第二步:通过code获取access_token
```
https://api.weixin.qq.com/sns/oauth2/access_token?appid=APPID&secret=SECRET&code=CODE&grant_type=authorization_code
```
```
{ 
"access_token":"ACCESS_TOKEN", 
"expires_in":7200, 
"refresh_token":"REFRESH_TOKEN",
"openid":"OPENID", 
"scope":"SCOPE",
"unionid":"o6_bmasdasdsad6_2sgVt7hMZOPfL"
}
```

- 第三步:通过access_token调用接口
```
获取access_token后，进行接口调用，有以下前提：
1. access_token有效且未超时；
2. 微信用户已授权给第三方应用帐号相应接口作用域（scope）。
```
```
# snsapi_base	
/sns/oauth2/access_token	通过code换取access_token、refresh_token和已授权scope
/sns/oauth2/refresh_token	刷新或续期access_token使用
/sns/auth	检查access_token有效性

# snsapi_userinfo	
/sns/userinfo	获取用户个人信息
```

- 示例代码
```
    wechat_get_access_token:function(paramI){
      var APPID = "wx42a074fa10fb4eda";
      var CODE = paramI.code;
      var SECRET="316c833e67586a6f3cbe615f3546a902";
      var authorization_code="authorization_code";
      return $http({
        url: Wosaiteach.weixin + '/oauth2/access_token'+"?appid="+APPID+"&secret="+SECRET+"&code="+CODE+"&grant_type="+authorization_code,
        method: 'GET',
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        }
      });
    },
    wechat_get_use_info:function(paramI){
      var access_token=paramI.access_token;
      var openid=paramI.paramI;
      return $http({
        url: Wosaiteach.weixin + '/userinfo?access_token='+access_token+"&openid="+openid,
        method: 'GET',
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        }
      });
    },
```
---
# QQ登录API说明
http://wiki.open.qq.com/wiki/website/%E4%BD%BF%E7%94%A8Authorization_Code%E8%8E%B7%E5%8F%96Access_Token

- 获取Access Token
```
Step1：获取Authorization Code
请求地址：
PC网站： https://graph.qq.com/oauth2.0/authorize 
WAP网站： https://graph.z.qq.com/moc2/authorize 
```
```
Step2：通过Authorization Code获取Access Token
请求地址：
PC网站：https://graph.qq.com/oauth2.0/token 
WAP网站：https://graph.z.qq.com/moc2/token 
```
```
Step3：（可选）权限自动续期，获取Access Token
Access_Token的有效期默认是3个月，过期后需要用户重新授权才能获得新的Access_Token。本步骤可以实现授权自动续期，避免要求用户再次授权的操作，提升用户体验。
请求地址：
PC网站：https://graph.qq.com/oauth2.0/token 
WAP网站：https://graph.z.qq.com/moc2/token 
```
- 获取用户OpenID
```
PC网站：https://graph.qq.com/oauth2.0/me?callback=JSON_CALLBACK&access_token=30BDECD58EF9F4DB4E7DDD11094049C2
WAP网站：https://graph.z.qq.com/moc2/me
```
- OpenAPI调用说明
```
以get_user_info接口为例：
（请将access_token，appid等参数值替换为你自己的）
https://graph.qq.com/user/get_user_info?access_token=YOUR_ACCESS_TOKEN&oauth_consumer_key=YOUR_APP_ID&openid=YOUR_OPENID
```

- 示例代码
```
    qq_get_openid:function(access_token){
       //return $http.jsonp('https://graph.qq.com/oauth2.0/me?callback=JSON_CALLBACK&access_token=30BDECD58EF9F4DB4E7DDD11094049C2');
      return $http({
        url: Wosaiteach.qqlink + 'oauth2.0/me?access_token='+access_token,
        method: 'GET',
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        }
      });
    },
    qq_get_use_info:function(paramI,token){
      var access_token=token;
      var openid=paramI.openid;
      var app_id=1104925711;
      return $http.get(Wosaiteach.qqlink + 'user/get_user_info?access_token='+access_token+'&oauth_consumer_key='+app_id+'&openid='+openid);

      //return $http.get('https://graph.qq.com/user/get_user_info?access_token=30BDECD58EF9F4DB4E7DDD11094049c2&oauth_consumer_key=1104925711&openid=59DA2E20A180E18B3627F945417FFF49');
    },
```
---
# 微博登录API说明
http://open.weibo.com/wiki/%E6%8E%88%E6%9D%83%E6%9C%BA%E5%88%B6
http://open.weibo.com/wiki/%E7%A7%BB%E5%8A%A8%E5%BA%94%E7%94%A8SSO%E6%8E%88%E6%9D%83
https://github.com/sinaweibosdk/weibo_android_sdk

```
OAuth2/authorize	请求用户授权Token
OAuth2/access_token	获取授权过的Access Token
OAuth2/get_token_info	授权信息查询接口
OAuth2/revokeoauth2	授权回收接口
```