/**
 * Created by Administrator on 2016/9/2 0002.
 */

(function () {
  'use strict';

  angular
    .module('starter')
    .factory('ShareFactory', MainFactory);

  function MainFactory($rootScope, $ionicLoading, $http, $httpFactory) {

    {
      // initShare();// 引入直接初始化
    }

    function initShare() {
      {
        var isInstall = initIsInstall();
        $rootScope.isInstall_wechat = isInstall.wechat;
        $rootScope.isInstall_qq = isInstall.qq;
        $rootScope.isInstall_weibo = isInstall.weibo;

        var auth = initAuth();
        $rootScope.auth_wechat = auth.wechat;
        $rootScope.auth_qq = auth.qq;
        $rootScope.auth_weibo = auth.weibo;

        var share = initShare();
        $rootScope.share_wechat = share.wechat;
        $rootScope.share_wechatTimeLine = share.wechatTimeLine;
        $rootScope.share_qq = share.qq;
        $rootScope.share_Qzone = share.Qzone;
        $rootScope.share_weibo = share.weibo;
      }

      /**
       * 第三方是否安装
       * @returns {{wechat: wechat, qq: qq, weibo: weibo}}
       */
      function initIsInstall() {
        return {
          wechat: function () {
            return window.share.wechat.installed().then(function (installed) {
              //$ionicLoading.show({template: installed});
              return installed;
            }, function (failReason) {
              //$ionicLoading.show({template: failReason});    // 失败提示
              return Promise.reject(failReason);
            })
          },
          qq: function () {
            return window.share.qq.installed().then(function (installed) {
              //$ionicLoading.show({template: installed});
              return installed;
            }, function (failReason) {
              //$ionicLoading.show({template: failReason});
              return Promise.reject(failReason);
            })
          },
          weibo: function () {
            return window.share.weibo.installed().then(function (installed) {
              //$ionicLoading.show({template: installed});
              return installed;
            }, function (failReason) {
              //$ionicLoading.show({template: failReason});
              return Promise.reject(failReason);
            })
          }
        }
      }

      /**
       * 第三方登录
       * @returns {{wechat: wechat, qq: qq, weibo: weibo}}
       */
      function initAuth() {
        return {
          wechat: function () {
            return window.share.wechat.auth().then(function (response) {
              $ionicLoading.show({template: response});

              return response;
            }, function (failReason) {
              $ionicLoading.show({template: failReason});
              return Promise.reject(failReason);
            })
          },
          qq: function () {

            return window.share.qq.auth().then(function (response) {
              $ionicLoading.show({template: response});
              return response;
            }, function (failReason) {
              $ionicLoading.show({template: failReason});
              return Promise.reject(failReason);
            })
          },
          weibo: function () {
            return window.share.weibo.auth().then(function (response) {
              $ionicLoading.show({template: response});
              return response;
            }, function (failReason) {
              $ionicLoading.show({template: failReason});
              return Promise.reject(failReason);
            })
          }
        }
      }

      /**
       * 第三方分享
       * @returns {{wechat: wechat, qq: qq, weibo: weibo}}
       * //分享类型：1qq空间，2微信朋友圈，3微博，4qq，5微信
       */
      function initShare() {
        return {
          wechat: wechat,
          wechatTimeLine: wechatTimeLine,
          qq: qq,
          Qzone: Qzone,
          weibo: weibo
        }

        function wechat(title, description, thumb, url) {

          // var title = 'title';
          // var description = 'description';
          // var thumb = 'https://cordova.apache.org/images/cordova_256.png';
          // var imageUrl = 'https://cordova.apache.org/images/cordova_256.png';
          // var imgs = ['https://cordova.apache.org/images/cordova_256.png'];
          // var url = 'http://tech.qq.com/';

          return window.share.wechat.share(title, description, thumb, url)
            .then(function (success) {
              //$ionicLoading.show({template: success});
              afterShare(_app.shareType.wechat);
              return success;
            }, function (errorMessage) {
              //$ionicLoading.show({template: errorMessage});
              return Promise.reject(errorMessage);
            })
        }

        function wechatTimeLine(title, description, thumb, url) {
          return window.share.wechat.shareTimeLine(title, description, thumb, url)
            .then(function (success) {
              //$ionicLoading.show({template: success});
              afterShare(_app.shareType.wechatTimeline);
              return success;
            }, function (errorMessage) {
              //$ionicLoading.show({template: errorMessage});
              return Promise.reject(errorMessage);
            })
        }

        function qq(title, description, imageUrl, url) {
          return window.share.qq.share(title, description, imageUrl, url)
            .then(function (success) {
              //$ionicLoading.show({template: success});
              afterShare(_app.shareType.qq);
              return success;
            }, function (errorMessage) {
              //$ionicLoading.show({template: errorMessage});
              return Promise.reject(errorMessage);
            })
        }

        function Qzone(title, description, imgs, url) {
          return window.share.qq.shareToQzone(title, description, imgs, url)
            .then(function (success) {
              //$ionicLoading.show({template: success});
              afterShare(_app.shareType.qzone);
              return success;
            }, function (errorMessage) {
              //$ionicLoading.show({template: errorMessage});
              return Promise.reject(errorMessage);
            })
        }

        function weibo(title, description, imageUrl, url) {
          return window.share.weibo.share(title, description, imageUrl, url)
            .then(function (success) {
              //$ionicLoading.show({template: success});
              afterShare(_app.shareType.weibo);
              return success;
            }, function (errorMessage) {
              //$ionicLoading.show({template: errorMessage});
              return Promise.reject(errorMessage);
            })
        }

        function afterShare(type) {
          shareGetGold(type);
        }

        function shareGetGold(type) {
          //alert('afterShare：'+type);
          appv.currentUser && $httpFactory.activity.shareGold(type).then(function (res) {
            if (res.data.result == 0) {
              //$ionicLoading.show({template:res.data.message});
            }
          });
        }
      }
    }


    var service = {
      initShare: initShare,
    };
    return service;
  }
})
();
