/**
 * Created by Administrator on 2016/9/2 0002.
 */

(function (window) {
  'use strict';
  var wechat = {
    installed: function () {
      return new Promise(function (resolve, reject) {
        Wechat.isInstalled(function (installed) {
          // alert("Wechat installed: " + (installed ? "Yes" : "No"));
          resolve(installed);
        });
      });
    },
    auth: function () {
      return new Promise(function (resolve, reject) {
        Wechat.auth("snsapi_userinfo", function (response) {
          // you may use response.code to get the access token.
          // alert(JSON.stringify(response));
          resolve(JSON.stringify(response));
        }, function (reason) {
          // alert("Failed: " + reason);
          reject(reason);
        });
      });
    },
    share: function (title, description, thumb, url) {
      return new Promise(function (resolve, reject) {

        // if (typeof Wechat === "undefined") {
        //   // alert("Wechat plugin is not installed.");
        //   reject("Wechat plugin is not installed.");
        //   return false;
        // }

        var params = {
          scene: Wechat.Scene.SESSION,
          message: {media: {}}
        };

        params.message.media.type = Wechat.Type.WEBPAGE;

        // params.message.title = "title";
        // params.message.description = "description";
        // params.message.thumb = "https://cordova.apache.org/images/cordova_256.png";
        // params.message.media.webpageUrl = "http://www.saixueba.com/";

        title && (params.message.title = title);
        description && (params.message.description = description);
        thumb && (params.message.thumb = thumb);
        url && (params.message.media.webpageUrl = url);

        Wechat.share(params, function () {
           //alert("Success：3333");
          resolve("Success");
        }, function (reason) {
           //alert("Failed: " + reason);
          reject(reason);
        });
      })
    },
    shareTimeLine: function (title, description, thumb, url) {
      return new Promise(function (resolve, reject) {

        // if (typeof Wechat === "undefined") {
        //   // alert("Wechat plugin is not installed.");
        //   reject("Wechat plugin is not installed.");
        //   return false;
        // }

        var params = {
          scene: Wechat.Scene.TIMELINE,
          message: {media: {}}
        };

        params.message.media.type = Wechat.Type.WEBPAGE;

        // params.message.title = "专访张小龙：产品之上的世界观";
        // params.message.description = "微信的平台化发展方向是否真的会让这个原本简洁的产品变得臃肿？在国际化发展方向上，微信面临的问题真的是文化差异壁垒吗？腾讯高级副总裁、微信产品负责人张小龙给出了自己的回复。";
        // params.message.thumb = "https://cordova.apache.org/images/cordova_256.png";
        // params.message.media.webpageUrl = "http://tech.qq.com/";

        title && (params.message.title = title);
        description && (params.message.description = description);
        thumb && (params.message.thumb = thumb);
        url && (params.message.media.webpageUrl = url);

        Wechat.share(params, function () {
          // alert("Success");
          resolve("Success");
        }, function (reason) {
          // alert("Failed: " + reason);
          reject(reason);
        });
      })
    }
  }

  var qq = {
    installed: function () {
      return new Promise(function (resolve, reject) {
        YCQQ.checkClientInstalled(function () {
          // console.log('client is installed');
          resolve(1);
        }, function () {
          // 如果安装的QQ客户端版本太低，不支持SSO登录也会返回没有安装客户端的错误
          // console.log('client is not installed');
          reject(0);
        });
      })
    },
    auth: function () {
      return new Promise(function (resolve, reject) {
        YCQQ.ssoLogin(function (args) {
          // alert("token is " + args.access_token);
          // alert("userid is " + args.userid);
          // alert("expires_time is " + new Date(parseInt(args.expires_time)) + " TimeStamp is " + args.expires_time);
          resolve(args);
        }, function (failReason) {
          // console.log(failReason);
          reject(failReason);
        });
      })

    },
    //get_openid:function(access_token){
    //  return $http({
    //    url: Wosaiteach.qqlink + 'oauth2.0/me?access_token='+access_token,
    //    method: 'GET',
    //    headers: {
    //      'Content-Type': 'application/x-www-form-urlencoded'
    //    }
    //  });
    //},
    //get_user_info:function(paramI,token){
    //  var access_token=token;
    //  var openid=paramI.openid;
    //  var app_id=1104925711;
    //  return $http.get(Wosaiteach.qqlink + 'user/get_user_info?access_token='+access_token+'&oauth_consumer_key='+app_id+'&openid='+openid);
    //
    //},
    share: function (title, description, imageUrl, url) {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.appName = "赛学霸物理";
        // args.url = "http://www.saixueba.com/";
        // args.title = "This is cordova QQ share ";
        // args.description = "This is cordova QQ share ";
        // args.imageUrl = '';

        title && (args.title = title);
        description && (args.description = description);
        imageUrl && (args.imageUrl = imageUrl);
        url && (args.url = url);

        YCQQ.shareToQQ(function () {
          // console.log("share success");
          // alert("YCQQ成功：");
          resolve(1);
        }, function (failReason) {
          // console.log(failReason);
          // alert("YCQQ失败："+JSON.stringify(failReason));
          reject(failReason);
        }, args);
      })
    },
    shareToQzone: function (title, description, imageUrl, url) {
      return new Promise(function (resolve, reject) {
        var args = {};
        // args.url = "http://www.baidu.com";
        // args.title = "This is cordova QZone share ";
        // args.description = "This is cordova QZone share ";
        // var imgs = ['https://www.baidu.com/img/bdlogo.png',
        //   'https://www.baidu.com/img/bdlogo.png',
        //   'https://www.baidu.com/img/bdlogo.png'];
        // args.imageUrl = imgs;

        title && (args.title = title);
        description && (args.description = description);
        imageUrl && (args.imageUrl = [imageUrl]);
        url && (args.url = url);

        YCQQ.shareToQzone(function () {
          // console.log("share success");
          resolve(1);
        }, function (failReason) {
          // console.log(failReason);
          reject(failReason);
        }, args);
      })
    }
  }

  var weibo = {
    installed: function () {
      return new Promise(function (resolve, reject) {
        YCWeibo.checkClientInstalled(function () {
          // console.log('client is installed');
          resolve(1);
        }, function () {
          // console.log('client is not installed');
          reject(0);
        });
      })
    },
    auth: function () {
      return new Promise(function (resolve, reject) {
        YCWeibo.ssoLogin(function (args) {
          // alert("access token is " + args.access_token);
          // alert("userid is " + args.userid);
          // alert("expires_time is " + new Date(parseInt(args.expires_time)) + " TimeStamp is " + args.expires_time);
          resolve(args);
        }, function (failReason) {
          // console.log(failReason);
          reject(failReason);
        });
      })
    },
    share: function (title, description, imageUrl, url) {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.defaultText = "";
        // args.url = "http://www.baidu.com";
        // args.title = "Baidu";
        // args.description = "This is Baidu";
        // args.imageUrl = "https://www.baidu.com/img/bdlogo.png";//if you don't have imageUrl,for android http://www.sinaimg.cn/blog/developer/wiki/LOGO_64x64.png will be the defualt one

        title && (args.title = title);
        description && (args.description = description);
        imageUrl && (args.imageUrl = imageUrl);
        url && (args.url = url);

        YCWeibo.shareToWeibo(function () {
          // alert("share success");
          resolve(1);
        }, function (failReason) {
          // alert(failReason);
          reject(failReason);
        }, args);
      })
    }
  }

  /**
   * 分享实现
   */
  window.share = {
    wechat: wechat,
    qq: qq,
    weibo: weibo
  }

})(window);

/**
 谈谈 ES6 的 Promise 对象 - ac黄博客精选 - SegmentFault`
 https://segmentfault.com/a/1190000002928371
 */
