/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('HomeCtrl', MainController)

  /**
   * _data.object[0-5] 分册书列表
   * _data.object[0]  具体分册的书
   * _data.object[0] 子集[书]
   * _data.object[0].knowPoints[0-n] 子集[书-章]
   * _data.object[0].knowPoints[0].knowPoints[0-n] 子集[书-章-节]
   * _data.object[0].knowPoints[0].knowPoints[0].knowPoints[0] 子集[书-章-节-知识点]
   */

  function MainController($scope, $state, HomeDataFactory, localStorageService, RouteData, $httpFactory, $ionicScrollDelegate) {
    console.time('HomeCtrl')

    {
      $scope.isChoice = true;
      $scope.choiceToggle = choiceToggle;

      var _data = HomeDataFactory;// 初始化数据

      initLocalStorage();// 初始化本地存储
      $scope.rotaeNum = $scope.isChoice ? 0 : 1;// 同步本地存储后,初始化翻转角度

      $scope.books = _data.object;// book选项

      $scope.choiceOpenBook = choiceOpenBook;
      $scope.openSection = openSection;
      $scope.everyDaySign = everyDaySign;

      animate_ripple();// 涟漪效果 ripple
      onLoaded();// 加载完成后
      stateChangeSuccess();
      
      console.timeEnd('HomeCtrl')
      console.timeEnd('Home state');
    }

    function onLoaded() {
      $scope.$watch('$viewContentLoaded', function () {
        console.timeEnd('Home page load');
        // $ionicNavBarDelegate.showBar(true);
      });
    }

    function stateChangeSuccess() {
      $scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
        console.log('from:', fromState.url, 'To:', toState.url, toState.controller, 'toParams:', toParams);
        if (toState.url == '/home') {
          $('.bar.bar-stable').css('background-color', '#279cea');
          $scope.rotaeNum = $scope.isChoice ? 0 : 1;// 重置
        }
      })
    }

    /**
     * 初始化本地存储
     */
    function initLocalStorage() {

      var path = window._config.domain_name_exp;//  "http://120.55.144.43/teach";
      var exePro = {'八年级上': 'teach_rjb_101', '八年级下': 'teach_rjb_102', '九年级': 'teach_rjb_103'};
      var chapterNum = 0;
      angular.forEach(_data.object, function (data1, index1, array) {// 书
        angular.forEach(data1.knowPoints, function (data2, index2, array) {// 章
          chapterNum += 1;
          angular.forEach(data2.knowPoints, function (data3, index3, array) {// 节
            data3.pic = "img/book/" + chapterNum + "/" + (index3 + 1) + ".png";
            angular.forEach(data3.knowPoints, function (data4, index4, array) {// 知识点
              data4.mobileUrl = path + "/" + exePro[data1.name] + "?chapterId=" + (chapterNum + '-' + (index3 + 1)) + "&menuId=" + (index4 + 1);// 知识点打开页面
            })
          })
        })
      });

      // 初始化本地存储
      _data.object[0].activity = 'activity';// 标记open
      localStorageService.set('openBook', _data.object[0]);
      $scope.openBook = _data.object[0];
      $scope.openBook.activity = 'activity';// 标记open
      localStorageService.bind($scope, 'openBook');

      $scope.isChoice = localStorageService.get('isChoice');
      localStorageService.bind($scope, 'isChoice');
    }

    /**
     * 签到
     */
    function everyDaySign() {
      // {"curRec":1,"message":"签到成功","object":{"addGold":1},"result":0,"totalRec":1}
      $httpFactory.everyDaySign();
    }

    function choiceOpenBook(book) {
      if (book.name == $scope.openBook.name) {
        choiceToggle();
        return;
      }

      !!$scope.isChoice && ($scope.isChoice = true);

      $scope.openBook.activity = null;
      book.activity = 'activity';
      $scope.openBook = book;
      choiceToggle();
      $ionicScrollDelegate.scrollTop();// 回到顶部
    }

    function choiceToggle() {
      $scope.rotaeNum = $scope.rotaeNum + 1;
      $scope.isChoice = !$scope.isChoice;
    }

    function openSection(event, section, chapter) {
      RouteData.section = {openSection: section};
      var colorData = _getImgColor(event.currentTarget.querySelector("img"));
      section.color = colorData;
      localStorageService.set('openSection', section);// 本地存储-节
      // localStorageService.set('openChapter', chapter);// 本地存储-章
      $state.go('app.section');
    }

    /**
     * 涟漪效果 ripple
     */
    function animate_ripple() {
      $(document).ready(function () {
        $(".paper").mousedown(function (e) {
          var ripple = $(this).find(".ripple");
          ripple.removeClass("animate-ripple");
          var x = parseInt(e.pageX - $(this).offset().left) - (ripple.width() / 2);
          var y = parseInt(e.pageY - $(this).offset().top) - (ripple.height() / 2);
          ripple.css({
            top: y,
            left: x
          }).addClass("animate-ripple");
        });
      });
    }

  }

})();
