/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('SectionCtrl', MainController)

  function MainController($scope, $state, localStorageService, RouteData) {

    {
      var points_read = initRead();// 初始化已读(知识点)
      $scope.openSection = openSectionSignRead(points_read);// 打开节信息中,知识点已读标记

      $('.bar.bar-stable').css('background-color', $scope.openSection.color);

      // $sope.openExp = openExp;
      $scope.f_openPoint = f_openPoint;//  打开知识点
      $scope.f_points_read = f_points_read;// 已读知识点(关闭内嵌浏览器时触发)
      $scope.toPractice = toPractice;// 节练习
    }

    /**
     * 初始化已读(知识点)
     * @returns {Array}
     */
    function initRead() {
      var points_read = [];
      if (!!localStorageService.get('points_read')) {
        points_read = localStorageService.get('points_read');
        $scope.points_read = points_read;
      }
      localStorageService.bind($scope, 'points_read');// 本地存储绑定
      return points_read;
    }

    /**
     * 打开节信息中,知识点已读标记
     * @param points_read
     */
    function openSectionSignRead(points_read) {
      // var section = RouteData.section.openSection;// 打开-节
      var section = localStorageService.get('openSection');// 打开-节(本地存储)
      for (var item in section.points) {// TODO section.points可能会从后端获取
        if (points_read.indexOf(section.points[item].pointname) > -1) {
          section.points[item].read = true;// 已读
        }
      }
      return section;
    }

    /**
     * 打开知识点
     * @param point
     */
    function f_openPoint(point) {
      var url = !!point.webUrl ? point.webUrl : 'http://www.baidu.com';
      var web = window.open(url, '_blank', 'location=no'); // cordova-plugin-inappbrowser

      web.addEventListener('loadstart', iabLoadStart);             //html页面加载前进行iabLoadStart函数操作
      // web.addEventListener('loadstop', iabLoadStop);             //html页面加载后进行iabLoadStop 函数操作
      // web.addEventListener('loaderror', iabLoadError);           //html页面加载错误时进行iabLoadError 函数操作
      web.addEventListener('exit', iabClose);                      //html页面关闭后进行iabClose 函数操作

      var startTime;

      function iabLoadStart() {
        startTime = +new Date();
        console.log('startTime', startTime);// TODO 设备上会触发两次,暂无影响
      }

      function iabClose() {
        var timeSum = (+new Date() - startTime) / 1000;
        if (startTime > 0 && timeSum > 2) {
          console.log('已阅', timeSum, point);
        }
      }
    }

    /**
     * 已读知识点(关闭内嵌浏览器时触发)
     * @param point
     */
    function f_points_read(point) {
      if (points_read.indexOf(point.pointname) == -1) {
        points_read.concat(point.pointname);
      }
    }

    /**
     * 节练习
     */
    function toPractice() {
      $state.go('app.practice');
    }

  }
})();
