/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('HomeCtrl', MainController)

  /**
   * _data.object[0-5] 分册书列表
   * _data.object[0]  具体分册的书
   * _data.object[0].knowList[0] 子集[书]
   * _data.object[0].knowList[0].knowPoints[0-n] 子集[书-章]
   * _data.object[0].knowList[0].knowPoints[0].knowPoints[0-n] 子集[书-章-节]
   * _data.object[0].knowList[0].knowPoints[0].knowPoints[0].knowPoints[0] 子集[书-章-节-知识点]
   */

  function MainController($scope, $state, HomeDataFactory, localStorageService, RouteData, $httpFactory,
                          ngDialog, $timeout, $compile, $templateCache, $http) {

    {
      $scope.isChoice = true;
      $scope.choiceToggle = choiceToggle;

      var _data = HomeDataFactory;// 初始化数据

      initLocalStorage();// 初始化本地存储

      $scope.books = _data.object;// book选项

      $scope.choiceOpenBook = choiceOpenBook;
      $scope.openSection = openSection;

      animate_ripple();// 涟漪效果 ripple
      onLoaded();// 加载完成后

      $scope.clickToOpen = clickToOpen;// TODO 测试全局弹窗

    }

    function onLoaded() {
      $scope.$on('$viewContentLoaded', function () {
        // _data.books
      });
    }

    /**
     * TODO 测试全局弹窗(用于自动获取金币提醒)
     */
    function clickToOpen() {
      $scope.clickToOpen = function () {
        //  $scope.number = Math.floor(Math.random() * 5) + 1;
        // ngDialog.open({template: 'app_module/gold/gold2.html',width: '80vw', className: 'ngdialog-theme-default',scope:$scope});

        /**
         * 弹出公共的金币奖励提示
         */
        $http.get('app_module/gold/gold.html', ({cache: $templateCache} || {})).then(function (response) {
          // 1.获取 template 标签
          var goldEL = angular.element(response.data);

          // 1.2 更新金币数量
          $scope.number = Math.floor(Math.random() * 5) + 1;
          $compile(goldEL)($scope);// 数据双向绑定

          // 2.动态添加template 标签
          angular.element(document).find('body').append(goldEL);

          // 3.1.5s后自动删除此标签
          $timeout(function () {
            goldEL.remove();
          }, 1500);
        });

      };
    }

    /**
     * 初始化本地存储
     */
    function initLocalStorage() {

      // 初始化本地存储
      if (!localStorageService.get('openBook')) {
        _data.object[0].knowList[0].activity = 'activity';// 标记open
        localStorageService.set('openBook', _data.object[0].knowList[0]);
        $scope.openBook = _data.object[0].knowList[0];
        $scope.openBook.activity = 'activity';// 标记open
      }
      localStorageService.bind($scope, 'openBook');

      if (!!localStorageService.get('isChoice')) {
        $scope.isChoice = localStorageService.get('isChoice');
      }
      localStorageService.bind($scope, 'isChoice');
    }

    /**
     * 从后台初始化数据(暂时未启用)
     */
    function initData() {
      $httpFactory.home.book(20).then(function (response) {
        console.log(response);
      })
    }

    function choiceOpenBook(book) {
      if (book.name == $scope.openBook.name) {
        return;
      }

      !!$scope.isChoice && ($scope.isChoice = true);

      $scope.openBook.activity = null;
      book.activity = 'activity';
      $scope.openBook = book;
      choiceToggle();
    }

    function choiceToggle() {
      $scope.isChoice = !$scope.isChoice;
    }

    function openSection(event, section) {
      // SectionRouteData.openSection = section;
      RouteData.section = {openSection: section};
      var colorData = _getImgColor(event.currentTarget.querySelector("img"));
      section.color = colorData;
      localStorageService.set('openSection', section);// 本地存储
      $state.go('app.section');
    }

    /**
     * 涟漪效果 ripple
     */
    function animate_ripple() {
      $(document).ready(function () {
        $(".paper").mousedown(function (e) {
          var ripple = $(this).find(".ripple");
          ripple.removeClass("animate-ripple");
          var x = parseInt(e.pageX - $(this).offset().left) - (ripple.width() / 2);
          var y = parseInt(e.pageY - $(this).offset().top) - (ripple.height() / 2);
          ripple.css({
            top: y,
            left: x
          }).addClass("animate-ripple");
        });
      });
    }

  }

})();
