/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('SectionCtrl', MainController)

  function MainController($scope, $rootScope, $state, $ionicPopup, localStorageService, $httpFactory) {

    {
      // var points_read = initRead();// 初始化已读(知识点)
      var openSection = localStorageService.get('openSection');// 打开-节(本地存储)
      initSectionShow();// 初始化节信息(含外部链接)

      $('.bar.bar-stable').css('background-color', openSection.color);// 设置主题色

      // $sope.openExp = openExp;
      $scope.shareExp = shareExp;// 分享
      $scope.f_openPoint = f_openPoint;//  打开知识点
      $scope.f_points_read = f_points_read;// 已读知识点(关闭内嵌浏览器时触发)
      $scope.toPractice = toPractice;// 节练习
    }

    function shareExp(point) {
      $scope.share = {
        inviteCode: appv.currentUser && appv.currentUser.inviteCode,
        items: [
          {imgSrc: 'img/share/qzone.png', name: 'Qzone', goldNum: 10},
          {imgSrc: 'img/share/wechatTimeline.png', name: 'wechatTimeline', goldNum: 10},
          {imgSrc: 'img/share/weibo.png', name: 'weibo', goldNum: 10},
          {imgSrc: 'img/share/qq.png', name: 'qq', goldNum: 5},
          {imgSrc: 'img/share/wechat.png', name: 'wechat', goldNum: 5}
        ],
        params: {
          title: 'title',
          description: 'description',
          thumb: 'https://cordova.apache.org/images/cordova_256.png',
          url: 'http://kexue.saixueba.com/king/'
        },
        remark: ""
      };

      for (var i in $scope.share.items) {
        f_isInstall($scope.share.items[i]);
      }

      $scope.f_share = f_share;// 分享
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/shareExp.html',
        scope: $scope
      });

      function f_isInstall(item) {
        if (_app.isWeb) {
          item.isInstall = 1;
          return;
        }

        switch (item.name) {
          case 'Qzone':
            $rootScope.isInstall_qq().then(success, fail);
            return true;
          case 'wechatTimeline':
            $rootScope.isInstall_wechat().then(success, fail);
            return true;
          case 'weibo':
            $rootScope.isInstall_weibo().then(success, fail);
            return true;
          case 'qq':
            $rootScope.isInstall_qq().then(success, fail);
            return true;
          case 'wechat':
            $rootScope.isInstall_wechat().then(success, fail);
            return true;
        }
        function success(response) {
          item.isInstall = response;
        }

        function fail(failResponse) {
          console.log(failResponse);
        }
      }

      function f_share(item, params) {
        // var params = [params.title, params.description, params.thumb, params.url];
        switch (item.name) {
          case 'Qzone':
            $rootScope.share_Qzone(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'wechatTimeline':
            $rootScope.share_wechatTimeLine(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'weibo':
            $rootScope.share_weibo(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'qq':
            $rootScope.share_qq(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'wechat':
            $rootScope.share_wechat(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
        }

        function success(response) {
          console.log('分享成功', response);
        }

        function fail(failResponse) {
          console.log('分享失败', failResponse);
        }
      }
    }

    /**
     * 初始化已读(知识点)
     * @returns {Array}
     */
    function initRead() {
      var points_read = [];
      if (!!localStorageService.get('points_read')) {
        points_read = localStorageService.get('points_read');
        $scope.points_read = points_read;
      }
      localStorageService.bind($scope, 'points_read');// 本地存储绑定
      return points_read;
    }

    /**
     * 初始化节信息(含外部链接)
     * @param points_read
     */
    function initSectionShow() {
      $httpFactory.section.getPoints(openSection.code).then(function (response) {
        // console.log(response);
        $scope.points = response.data.object
      })

      // var section = localStorageService.get('openSection');// 打开-节(本地存储)
      // for (var item in section.points) {
      //   if (points_read.indexOf(section.points[item].name) > -1) {
      //     section.points[item].read = true;// 已读
      //   }
      // }
      // return section;
    }

    /**
     * 打开知识点
     * @param point
     */
    function f_openPoint(point) {
      var url = !!point.webUrl ? point.webUrl : 'http://www.baidu.com';
      var web = window.open(url, '_blank', 'location=no'); // cordova-plugin-inappbrowser

      web.addEventListener('loadstart', iabLoadStart);             //html页面加载前进行iabLoadStart函数操作
      // web.addEventListener('loadstop', iabLoadStop);             //html页面加载后进行iabLoadStop 函数操作
      // web.addEventListener('loaderror', iabLoadError);           //html页面加载错误时进行iabLoadError 函数操作
      web.addEventListener('exit', iabClose);                      //html页面关闭后进行iabClose 函数操作

      var startTime;

      function iabLoadStart() {
        startTime = +new Date();
        console.log('startTime', startTime);// TODO 设备上会触发两次,暂无影响
      }

      function iabClose() {
        var timeSum = (+new Date() - startTime) / 1000;
        if (startTime > 0 && timeSum > 2) {
          console.log('已阅', timeSum, point);
          f_points_read(point);// 已阅
        }
      }
    }

    /**
     * 已读知识点(关闭内嵌浏览器时触发)
     * @param point
     */
    function f_points_read(point) {
      $httpFactory.section.expRead(point.code);

      // if (points_read.indexOf(point.name) == -1) {
      //   points_read.concat(point.name);
      // }
    }

    /**
     * 节练习
     */
    function toPractice() {
      $state.go('app.practice');
    }

  }
})();
