/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('HomeCtrl', MainController)

  /**
   * _data.knowPoints[0-5] 分册书列表
   * _data.knowPoints[0]  具体分册的书
   * _data.knowPoints[0] 子集[书]
   * _data.knowPoints[0].knowPoints[0-n] 子集[书-章]
   * _data.knowPoints[0].knowPoints[0].knowPoints[0-n] 子集[书-章-节]
   * _data.knowPoints[0].knowPoints[0].knowPoints[0].knowPoints[0] 子集[书-章-节-知识点]
   */

  function MainController($scope, $state, HomeDataFactory, localStorageService, RouteData, $httpFactory, $ionicScrollDelegate, $cordovaAppVersion, $ionicPopup) {
    console.time('HomeCtrl');

    {
      $scope.isChoice = true;
      $scope.choiceToggle = choiceToggle;

      var _data = HomeDataFactory.object[0];// 初始化数据

      initLocalStorage();// 初始化本地存储
      $scope.rotaeNum = $scope.isChoice ? 0 : 1;// 同步本地存储后,初始化翻转角度

      $scope.books = _data.knowPoints;// book选项

      $scope.choiceOpenBook = choiceOpenBook;
      $scope.openSection = openSection;

      onLoaded();// 加载完成后
      stateChangeSuccess();

      (appv.currentUser && !window.isEveryDaySign) ? $httpFactory.everyDaySign() : '';// 自动签到(场景:二次打开,自动登录)
      window.isCheckCVersion ? (window.isCheckCVersion = true) : checkVersion();// 版本更新

      console.timeEnd('HomeCtrl');
      console.timeEnd('Home state');
    }

    function onLoaded() {
      $scope.$watch('$viewContentLoaded', function () {
        console.log('b', $(".paper").length);
        console.timeEnd('Home page load');
      });
    }

    function stateChangeSuccess() {
      $scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
        // console.log('from:', fromState.url, 'To:', toState.url, toState.controller, 'toParams:', toParams);
        if (toState.url == '/home') {
          $('.bar.bar-stable').css('background-color', '#279cea');
          $scope.rotaeNum = $scope.isChoice ? 0 : 1;// 重置
        }
      })
    }

    /**
     * 初始化本地存储
     */
    function initLocalStorage() {

      var path = window._config.domain_name_exp;//  "http://120.55.144.43/teach";
      var exePro = {'八年级上': 'teach_rjb_101', '八年级下': 'teach_rjb_102', '九年级': 'teach_rjb_103'};
      var chapterNum = 0;
      angular.forEach(_data.knowPoints, function (data1, index1, array) {// 书
        angular.forEach(data1.knowPoints, function (data2, index2, array) {// 章
          chapterNum += 1;
          angular.forEach(data2.knowPoints, function (data3, index3, array) {// 节
            data3.pic = "img/book/" + chapterNum + "/" + (index3 + 1) + ".jpg";
            angular.forEach(data3.knowPoints, function (data4, index4, array) {// 知识点
              data4.mobileUrl = path + "/" + exePro[data1.name] + "?chapterId=" + (chapterNum + '-' + (index3 + 1)) + "&menuId=" + (index4 + 1);// 知识点打开页面
            })
          })
        })
      });

      // 初始化本地存储
      _data.knowPoints[0].activity = 'activity';// 标记open
      var openBook_local = localStorageService.get('openBook');
      if (openBook_local) {
        $scope.openBook = openBook_local;
      } else {
        localStorageService.set('openBook', _data.knowPoints[0]);
        $scope.openBook = _data.knowPoints[0];
      }
      $scope.openBook.activity = 'activity';// 标记open
      setTimeout(function () {
        animate_ripple()
      }, 200);// 初始化涟漪效果
      localStorageService.bind($scope, 'openBook');

      $scope.isChoice = localStorageService.get('isChoice');
      localStorageService.bind($scope, 'isChoice');
    }

    /*检查是否有新版本*/
    function checkVersion() {
      // return ;// TODO debug
      if (!_app.isAndroid) {
        return;
      }

      $httpFactory.versionQuery_1802().then(function (res) {
        if (res.data.result == 0) {
          if (_app.isWeb) {
            return;
            /*web版本没有更新*/
          }
          $cordovaAppVersion.getVersionCode().then(function (version) {
            $scope.lastVersion = res.data.object.lastVersion;
            if ($scope.lastVersion.versionNo <= version) {
              return;
              /*无需更新*/
            }

            $scope.downNewVersion = downNewVersion;
            // $scope.popupColse = popupColse;
            // $scope.force_update = false;// 是否强制更新

            if (res.data.object.forceUpdate) {
              /* 强制更新 */
              $scope.force_update = true;
            }

            $scope.myPopup = $ionicPopup.show({
              cssClass: 'myPopup',
              templateUrl: 'app/app/update.html',
              scope: $scope
            });
            $scope.myPopup.then(function (res) {
              if ($scope.force_update) {
                /*强制更新,返回退出*/
                ionic.Platform.exitApp();
              }
            });

            // function popupColse() {
            //   if ($scope.force_update) {
            //     return;
            //   }
            //   $scope.myPopup.close();
            // }
          });
        } else {
          my.log("错误：" + res.data.message);
        }
      });

      /* 跳转浏览器,下载新版本 */
      function downNewVersion() {
        window.open($scope.lastVersion.versionUrl, '_system');
      }
    }

    function choiceOpenBook(book) {
      if (book.name == $scope.openBook.name) {
        choiceToggle();
        return;
      }

      !!$scope.isChoice && ($scope.isChoice = true);

      $scope.openBook.activity = null;
      book.activity = 'activity';
      $scope.openBook = book;
      choiceToggle();
      $ionicScrollDelegate.scrollTop();// 回到顶部
      setTimeout(function () {
        animate_ripple()
      }, 200);// 初始化涟漪效果
    }

    function choiceToggle() {
      $scope.rotaeNum = $scope.rotaeNum + 1;
      $scope.isChoice = !$scope.isChoice;
    }

    function openSection(event, section, chapter) {
      RouteData.section = {openSection: section};
      var colorData = _getImgColor(event.currentTarget.querySelector("img"));
      section.color = colorData;
      localStorageService.set('openSection', section);// 本地存储-节
      setTimeout(function () {
        $state.go('app.section')
      }, 200);
    }

    /**
     * 涟漪效果 ripple
     */
    function animate_ripple() {
      return true;// 影响性能,暂时关闭
      $(".paper")
        .click(function (e) {
          var ripple = $(this).find(".ripple");
          ripple.removeClass("animate-ripple");
          var x = parseInt(e.pageX - $(this).offset().left) - (ripple.width() / 2);
          var y = parseInt(e.pageY - $(this).offset().top) - (ripple.height() / 2);
          ripple.css({
            top: y,
            left: x
          }).addClass("animate-ripple");
        })
    }

  }

})();
