/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('SectionCtrl', MainController)

  function MainController($scope, $rootScope, $state, $ionicPopup, localStorageService, $httpFactory, $ionicNavBarDelegate) {

    {
      $scope.shareExp = shareExp;// 分享
      $scope.f_openPoint = f_openPoint;//  打开知识点
      $scope.f_points_read = f_points_read;// 已读知识点(关闭内嵌浏览器时触发)
      $scope.toPractice = toPractice;// 节练习
      // initPracticeOpen();

      $scope.openSection = localStorageService.get('openSection');// 打开-节(本地存储)
      initSectionShow();// 初始化节信息(含外部链接)
      $('.bar.bar-stable').css('background-color', $scope.openSection.color);// 设置主题色

      // $scope.choiceNavBar = choiceNavBar;
      // $scope.choicePortrait = choicePortrait;

      // preLoading();// 实验预加载
      // stateChangeSuccess();// 路由更新

    }

    /**
     * 已阅标记
     */
    // function initPracticeOpen() {
    //   $httpFactory.sys.config('practiceOpen').then(function (res) {
    //     if (res.data.result == 0) {
    //       if (res.data.object[0].value == 'true') {
    //         $scope.practiceOpen = true;
    //       } else {
    //         $scope.practiceOpen = false;
    //       }
    //     }
    //   });
    // }

    /**
     * 分享
     * @param point
     */
    function shareExp() {
      $scope.share = {
        inviteCode: appv.currentUser && appv.currentUser.inviteCode,
        items: [
          {imgSrc: 'img/icon/qzone.png', name: 'Qzone', goldNum: 10},
          {imgSrc: 'img/icon/wechatTimeline.png', name: 'wechatTimeline', goldNum: 10},
          //{imgSrc: 'img/icon/weibo.png', name: 'weibo', goldNum: 10},
          //{imgSrc: 'img/icon/qq.min.png', name: 'qq', goldNum: 5},
          {imgSrc: 'img/icon/wechat.min.png', name: 'wechat', goldNum: 5}
        ],
        // thumb:  'http://wuli.saixueba.com/resources/'+ $scope.openSection.pic.replace('book', 'icon/book').replace('png','jpg'),
        params: {
          title: $scope.openSection.name,
          description: $scope.openSection.name,
          thumb: 'http://wuli.saixueba.com/resources/' + $scope.openSection.pic,
          url: 'http://wuli.saixueba.com/share_experiment/share.html?code=' + $scope.openSection.code
        },
        remark: ""
      };

      for (var i in $scope.share.items) {
        f_isInstall($scope.share.items[i]);
      }

      $scope.f_share = f_share;// 分享
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/shareExp.html',
        scope: $scope
      });

      function f_isInstall(item) {
        item.isInstall = 1;// 默认存在,失效时隐藏

        if (_app.isWeb) {
          return;
        }

        switch (item.name) {
          case 'Qzone':
            $rootScope.isInstall_qq().then(success, fail);
            break;
          case 'wechatTimeline':
            $rootScope.isInstall_wechat().then(success, fail);
            break;
          case 'weibo':
            $rootScope.isInstall_weibo().then(success, fail);
            break;
          case 'qq':
            $rootScope.isInstall_qq().then(success, fail);
            break;
          case 'wechat':
            $rootScope.isInstall_wechat().then(success, fail);
            break;
          default:
            break;
        }

        function success(response) {
          item.isInstall = 1;
          $scope.$apply();
        }

        function fail(failResponse) {
          item.isInstall = 0;
          console.log(failResponse);
          $scope.$apply();
        }
      }

      function f_share(item, params) {
        // var params = [params.title, params.description, params.thumb, params.url];
        switch (item.name) {
          case 'Qzone':
            $rootScope.share_Qzone(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'wechatTimeline':
            $rootScope.share_wechatTimeLine(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'weibo':
            $rootScope.share_weibo(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'qq':
            $rootScope.share_qq(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'wechat':
            $rootScope.share_wechat(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
        }

        function success(response) {
          console.log('分享成功', response);
        }

        function fail(failResponse) {
          console.log('分享失败', failResponse);
        }
      }
    }

    /**
     * 初始化已读(知识点)
     * @returns {Array}
     */
    function initRead() {
      var points_read = [];
      if (!!localStorageService.get('points_read')) {
        points_read = localStorageService.get('points_read');
        $scope.points_read = points_read;
      }
      localStorageService.bind($scope, 'points_read');// 本地存储绑定
      return points_read;
    }

    /**
     * 初始化节信息(含外部链接)
     * @param points_read
     */
    function initSectionShow() {

      // 借助上次缓存,快速显示
      // localStorageService.get('openSection[' + $scope.openSection.code + ']_points') && ($scope.points = localStorageService.get('openSection_points'));

      appv.currentUser && $httpFactory.section.getPoints($scope.openSection.code).then(function (response) {
        // console.log(response);
        response.data && ($scope.points = response.data.object[0].knowPoints);
        // localStorageService.set('openSection[' + $scope.openSection.code + ']_points', $scope.points);

        // 同步已读信息与实验信息
        var rp_points = response.data.object[0].knowPoints;
        for (var i in $scope.openSection.knowPoints) {
          var point = $scope.openSection.knowPoints[i];
          point.knowExpList = rp_points[i].knowExpList;
        }
      })
    }

    /**
     * 实验预加载
     * @param point
     * @param index
     */
    function preLoading() {
      angular.forEach($scope.openSection.knowPoints, function (data, index, array) {
        (function (data) {
          data.webView = window.open(data.mobileUrl, '_blank', 'location=no,toolbar=no,hidden=no,hidden=yes' + (_app.isAndroid ? ',immersion=yes' : ''));
          data.webView && (data.webView.mobileUrl = data.mobileUrl);
          data.webView && data.webView.addEventListener('loadstop', function () {
            data.webView_loadstop = true;
            console.log(data.name, 'webView_loadstop');
          });
          data.webView.addEventListener('mycmd',
            function (cmd) {
              var cmd = cmd.args.split(':');
              cmd[0] == 'close' ? data.webView.close() : '';
            });
        })(data);// 闭包
      })
      console.log('knowPoints:', $scope.openSection.knowPoints);
    }

    function f_openPoint_temp(point, index) {
      console.log(point.name, point.webView_loadstop);

      window.screen.lockOrientation("landscape");// 横屏进入,避免自适应排版问题
      window.addEventListener("orientationchange", orientatinchangeEvent);// 横屏完成事件
      function orientatinchangeEvent() {

        if (window.screen.orientation == 'portrait-primary'
          || window.screen.orientation.type == 'portrait-primary') {// android需要使用orientation.type
          return;
        }

        point.webView.show();// 显示窗口

        // 注册关闭事件
        point.webView.addEventListener('exit', iabClose);                      //html页面关闭后进行iabClose 函数操作
        function iabClose(event) {
          window.removeEventListener("orientationchange", orientatinchangeEvent);// 删除当前事件监听
          window.screen.lockOrientation("portrait");
        }
      }
    }

    // var isShowBar;
    // function choiceNavBar() {
    //   isShowBar = !isShowBar;
    //   $ionicNavBarDelegate.showBar(isShowBar);
    // }

    // var isAllowChoice;
    // function choicePortrait() {
    //   if (isAllowChoice) {
    //     window.screen.lockOrientation("portrait");// 恢复竖屏
    //     isAllowChoice = !isAllowChoice;
    //   }
    // }

    /**
     * 打开知识点
     * @param point
     */
    function f_openPoint(point, index) {

      // !_app.isWeb && $ionicNavBarDelegate.showBar(false);
      $ionicNavBarDelegate.showBar(false);

      if (_app.isWeb) {
        window.open(point.mobileUrl, '_blank', 'location=no,immersion=yes,toolbar=no');
        return;
      }

      var immersion;
      if (_app.isAndroid && navigator.userAgent.indexOf('PAD') < 0) {
        immersion = ',immersion=yes';
      }
      var web = window.open(point.mobileUrl, '_blank', 'location=no,toolbar=no,hidden=no,hidden=yes' + immersion); // cordova-plugin-inappbrowser

      window.screen.lockOrientation("landscape");// 横屏进入,避免自适应排版问题

      if (web) {
        web.addEventListener('loadstart', iabLoadStart);             //html页面加载前进行iabLoadStart函数操作
        web.addEventListener('loadstop', isLoadstop);             //html页面加载后进行iabLoadStop 函数操作
        // web.addEventListener('loaderror', iabLoadError);           //html页面加载错误时进行iabLoadError 函数操作
        web.addEventListener('exit', iabClose);                      //html页面关闭后进行iabClose 函数操作
        web.addEventListener('mycmd', mycmd);                      //html页面关闭后进行iabClose 函数操作

        $scope.web = web;// 绑定到页面提供页面关闭功能
      }

      var startTime;

      function iabLoadStart(event) {
        // window.screen.lockOrientation("landscape");
        startTime = +new Date();
      }

      function isLoadstop() {
        isLoadstop_handle();
      }

      function isLoadstop_handle() {
        $ionicNavBarDelegate.showBar(true);
        $scope.$apply();

        web.show();// 显示窗口
        // setTimeout(function(){isAllowChoice = true},2000);
      }

      function iabClose(event) {
        window.screen.lockOrientation("portrait");// 恢复竖屏
      }

      function mycmd(cmd) {
        var cmd = cmd.args.split(':');

        switch (cmd[0]) {
          case 'close':
            web.close();
            return true;
          case 'loadstop':
            isLoadstop_handle();
            return true;
        }
      }

      // var expHanler;
      // document.addEventListener("pause", function () {
      //   console.log('pause');
      //   expHanler = true;
      // }, false);
      //
      // document.addEventListener("resume", function () {
      //   console.log('resume');
      //   expHanler && iabClose();// 回到客户端,调用实验关闭事件处理,恢复竖屏
      //   expHanler == false;// 执行完毕
      // }, false);


    }

    /**
     * 已读知识点(关闭内嵌浏览器时触发)
     * @param point
     */
    function f_points_read(point) {
      if (point.knowExpList == null || point.knowExpList.length == 0) {
        point.knowExpList = [{'isRead': 1}];
        $scope.$apply();
        return;
      }

      point.knowExpList[0].isRead = 1;
      $scope.$apply();
      point.knowExpList[0].expCode && $httpFactory.section.expRead(point.knowExpList[0].expCode);
    }

    /**
     * 节练习
     */
    function toPractice() {
      $state.go('app.practice');
    }

  }
})();
