/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular
    .module('starter')
    .factory('LoginFactory', MainFactory);

  function MainFactory($ionicModal, $httpFactory, $timeout, $ionicLoading, $state, RegUtil, $interval, $rootScope, $http, localStorageService, $ionicHistory) {

    function initLoginModal($scope) {
      {
        initModal();
        checkInstall();        //第三方安装

        $scope.login = login;
        $scope.closeLogin = closeLogin;
        $scope.doLogin = doLogin;
        $scope.sendCode = sendCode;
        $scope.text = '发送';
        $scope.second = 60;
        $scope.changeLogin = changeLogin;

        //$scope.isOneLogin = true;
        //$scope.userInfo = appv.currentUser;
        //$scope.bookGold = appv.bookGold;
        //$scope.loginData = {};
        //$scope.mobileLogin = {};
        //$scope.isLogin = appv.currentUser ? true : false
        //checkRedInfo();

        refreshLoginInfo();
        $scope.refreshLoginInfo = refreshLoginInfo;

        $scope.loginQQ = loginQQ;
        $scope.loginWechat = loginWechat;
        var wetcharLink = 'https://api.weixin.qq.com/sns';
      }

      function refreshLoginInfo() {
        $scope.isOneLogin = true;
        $scope.userInfo = appv.currentUser;
        $scope.bookGold = appv.bookGold;
        $scope.loginData = {};
        $scope.mobileLogin = {};
        $scope.isLogin = appv.currentUser ? true : false
        checkRedInfo();
      }

      function checkInstall() {
        if (_app.isWeb) {
          return
        }

        $scope.hasQQ = $scope.hasWechat = $scope.hasWeibo = 1;
        window.share.qq.installed().then(function (installed) {
          $scope.hasQQ = installed;
        }, function (res) {
          $scope.hasQQ = 0;
        });
        window.share.wechat.installed().then(function (installed) {
          $scope.hasWechat = installed;
        }, function (res) {
          $scope.hasWechat = 0;
        });
        window.share.weibo.installed().then(function (installed) {
          $scope.hasWeibo = installed;
        }, function (res) {
          $scope.hasWeibo = 0;
        });
      }

      function loginQQ() {
        $ionicLoading.show({template:'<ion-spinner icon="ios-small"></ion-spinner><span>正在打开...</span>'});
        window.share.qq.auth().then(function (res) {
          var qqLink = 'https://graph.qq.com/';
          var token = res.access_token;
          $http.get(qqLink + 'oauth2.0/me?access_token=' + token).then(function (res) {
            //截取openid段数据
            res = JSON.stringify(res);
            var firstworld = res.indexOf("(");
            var lastworld = res.lastIndexOf(')');
            var data = JSON.parse((res.substring(firstworld + 1, lastworld)).replace(/\\/g, ""));
            //赋值
            var access_token = token;
            var openid = data.openid;
            var app_id = data.client_id;
            $http.get(qqLink + 'user/get_user_info?access_token=' + access_token + '&oauth_consumer_key=' + app_id + '&openid=' + openid).then(function (res) {
              var data = {
                content: JSON.stringify({
                  nickName: res.data.nickname,
                  icon1: res.data.figureurl_qq_1,
                  sex: res.data.gender == '男' ? 'male' : 'female',
                  openId: openid,
                  imei: getImei(),
                  logo: 2
                })
              };
              $httpFactory.login.thirdLogin(data).then(function (res) {
                afterLogin(res);
              });
            });
          });
        });
      }

      function loginWechat() {
        $ionicLoading.show({template:'<ion-spinner icon="ios-small"></ion-spinner><span>正在打开...</span>'});
        window.share.wechat.auth().then(function (response) {
          response = JSON.parse(response);
          var wechatLink = 'https://api.weixin.qq.com/sns';
          var APPID = "wx053be7b51c59b5a7";
          var CODE = response.code;
          var SECRET = "ca6fcdc7e8a48d1ed94e52aae02c0a0c";
          var authorization_code = "authorization_code";
          //alert("地址："+wechatLink + '/oauth2/access_token' + "?appid=" + APPID + "&secret=" + SECRET + "&code=" + CODE + "&grant_type=" + authorization_code);
          $http.get(wechatLink + '/oauth2/access_token' + "?appid=" + APPID + "&secret=" + SECRET + "&code=" + CODE + "&grant_type=" + authorization_code).then(function (res) {
            //alert("转化前："+JSON.stringify(res));
            //alert(res);
            var token = res.data.access_token;
            var openId = res.data.openid;
            $http.get(wechatLink + '/userinfo?access_token=' + token + "&openid=" + openId).then(function (res) {
              //alert("转化前："+JSON.stringify(res));
              //alert(res);
              var data = {
                content: JSON.stringify({
                  nickName: res.data.nickname,
                  icon1: res.data.headimgurl,
                  sex: res.data.sex == '0' ? 'male' : 'female',
                  openId: res.data.openid,
                  imei: getImei(),
                  logo: 1
                })
              };
              $httpFactory.login.thirdLogin(data).then(function (res) {
                afterLogin(res);
              });
            });
          });
        });
      }

      function qq_get_use_info(paramI, token) {
        var access_token = token;
        var openid = paramI.openid;
        var app_id = 1104925711;
        return $http.get(qqLink + 'user/get_user_info?access_token=' + access_token + '&oauth_consumer_key=' + app_id + '&openid=' + openid);
      }

      function initModal() {
        // 初始化弹窗模板
        $ionicModal.fromTemplateUrl('app/login/login.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function (modal) {
          $scope.modal = modal;
        });

        // //当我们用完模型时，清除它！
        // $scope.$on('$destroy', function () {
        //   $scope.modal.remove();
        //   window.isLoginShow = false;
        // });
        // // 当隐藏模型时执行动作
        // $scope.$on('modal.hide', function () {
        //   // 执行动作
        //   window.isLoginShow = false;
        // });
        // // 当移动模型时执行动作
        // $scope.$on('modal.removed', function () {
        //   // 执行动作
        //   window.isLoginShow = false;
        // });
      }

      function changeLogin() {
        $scope.isOneLogin = !$scope.isOneLogin;
        if ($scope.isOneLogin) {
          $('h1.title').text('一键登录');
        } else {
          $('h1.title').text('用户名登录');
        }
      }

      // 隐藏登录弹窗
      function closeLogin() {
        $scope.modal.hide();
      }

      // Open the login modal
      function login() {
        $scope.modalHeight = {
          height:$('ion-modal-view').height()-54+'px'
        };
        $scope.modal.show();
        // $ionicHistory.clearHistory();// 删除历史
      }

      //登录
      function doLogin() {
        //一键登录
        if ($scope.isOneLogin) {
          var mobile = $scope.mobileLogin.mobile;
          var code = $scope.mobileLogin.code;
          checkOneLogin(mobile, code);
          var data = {
            content: JSON.stringify({
              mobile: mobile,
              imei: getImei(),
              authCode: code
            })
          };
          $httpFactory.login.oneLogin(data).then(function (res) {
            afterLogin(res);
          });
        }
        //普通登录
        else {
          var loginName = $scope.loginData.loginName;
          var password = $scope.loginData.password;
          checkNormalLogin(loginName, password);
          var data = {
            content: JSON.stringify({
              loginName: loginName,
              imei: getImei(),
              password: password
            })
          };
          $httpFactory.login.normal(data).then(function (res) {
            afterLogin(res);
          });
        }
      }

      function checkOneLogin(mobile, code) {
        if (!mobile) {
          $ionicLoading.show({template: '请输入手机号'});
          return;
        }
        if (!RegUtil.mobile(mobile)) {
          return;
        }
        if (!code) {
          $ionicLoading.show({template: '请输入验证码'});
          return;
        }
      }

      function checkNormalLogin(loginName, password) {
        if (!loginName) {
          $ionicLoading.show({template: '请输入用户名'});
          return;
        }
        if (!password) {
          $ionicLoading.show({template: '请输入密码'});
          return;
        }
      }

      function checkRedInfo() {
        //查询红点信息
        appv.currentUser && $httpFactory.user.redInfo().then(function (res) {
          if (res.data.result == 0) {
            $rootScope.redInfo = res.data.object.object;
          }
        });
      }

      function afterLogin(res) {
        if (res.data.result == 0) {
          $ionicLoading.show({template: '登录成功！'});
          appv.bookGold = res.data.object.bookGold;
          appv.currentUser = res.data.object.user;
          appv.token = res.data.object.token;

          $httpFactory.setToken(res.data.object.token);
          localStorageService.set('token', appv.token);
          localStorageService.set('currentUser', appv.currentUser);
          localStorageService.set('bookGold', appv.bookGold);
          $scope.userInfo = appv.currentUser;
          $scope.bookGold = appv.bookGold;
          $scope.isLogin = true;

          $timeout(function () {
            $scope.closeLogin();

          });
          //查询红点信息
          checkRedInfo();

          $httpFactory.everyDaySign();// 自动签到(场景:游客或用户A切换用户B登录)

          //页面跳转
          $state.go('app.home');
        }
        //登录失败
        else {
          $ionicLoading.show({template: res.data.message});
        }
      }

      //发送验证码
      function sendCode() {
        //检查
        var mobile = $scope.mobileLogin.mobile;
        if (!mobile) {
          $ionicLoading.show({template: '请输入手机号码！'});
          return;
        }
        if (!RegUtil.mobile(mobile)) {
          return;
        }

        //倒计时
        var timeStop = $interval(function () {
          if ($scope.second <= 0) {
            $interval.cancel(timeStop);
            $scope.text = '发送';
            $scope.second = 60;
            $scope.color = {};
          } else {
            $scope.text = '已发送(' + $scope.second + ')';
            $scope.color = {'color': '#959595'};
            $scope.second--
          }
        }, 1000);

        //发送验证码
        var data = {
          content: JSON.stringify({
            mobile: mobile,
            type: 3
          })
        };
        $httpFactory.login.getCode(data).then(function (res) {
          if (res.data.result == 0) {
            $ionicLoading.show({template: res.data.message});
          } else {
            $ionicLoading.show({template: res.data.message});
          }
        })
      }

      function getImei() {
        var imei = "";
        if (_app.isAndroid || _app.isIos) {
          imei = device.uuid;
        }
        return imei;
      }
    }

    var service = {
      initLoginModal: initLoginModal
    };
    return service;
  }
})();


