/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('PracticeCtrl', MainController)

  /**
   * practice 练习
   * openSection 打开节-信息
   * questionRoot 打开节-题集
   * openQuestion 当前打开题
   */

  function MainController($scope, $state, $httpFactory, localStorageService, RouteData, $ionicHistory, $ionicScrollDelegate) {

    {
      console.log('viewHistory', $ionicHistory.viewHistory());
      var questionRoot;// 打开节-题集 initData()中初始化
      $scope.index = 1;// 先定义位置
      initData();// 获取练习题(showOption显示题目中依赖位置定义)

      $scope.up = up;
      $scope.next = next;
    }

    function initData() {
      $scope.openSection = localStorageService.get('openSection');// 打开-节(本地存储)

      // questionRoot = PracticeDataFactory;// 依据节,获取节练习题
      $httpFactory.practice.getPractices($scope.openSection.code).then(function (request) {
        questionRoot = request;
        showOption();// 显示题目
      });
    }

    function up() {
      if ($scope.index == 1) {
        return;
      }

      $('.step li:nth-child(' + $scope.index + ')').removeClass('active');
      $('.step li:nth-child(' + $scope.index + ')').addClass('passive')
        .on("webkitAnimationEnd animationend", function () {
          $(this).removeClass('passive');
        });

      $scope.index = $scope.index - 1;
      showOption();
    }

    function next(option) {

      $scope.openQuestion.userResult = option.id;// 登记用户作答
      console.log($scope.index, $scope.openQuestion.result, $scope.openQuestion.userResult);
      $('.step li:nth-child(' + ($scope.index + 1) + ')').addClass('active');

      if ($scope.index == 5) {
        submitTranscripts();// 提交成绩单
        return;
      }

      $scope.index = $scope.index + 1;
      showOption();// 显示题目
    }

    /**
     * 显示题目
     */
    function showOption() {
      $scope.openQuestion = questionRoot.data.object[$scope.index - 1].question;
      $ionicScrollDelegate.scrollTop();// 回到顶部
    }

    function submitTranscripts() {
      RouteData.transcripts = {questionRoot: questionRoot};
      localStorageService.set('transcripts', {questionRoot: questionRoot});

      var content = {knowCode: $scope.openSection.code, list: []};
      angular.forEach(questionRoot.data.object, function (data, index, array) {
        content.list.push({
          questionCode: data.code,
          result: data.question.userResult,
          isTrue: (data.question.result == data.question.userResult ? 1 : 0)
        });
      });

      $httpFactory.practice.exercise(content);// 提交成绩

      $state.go('app.transcripts');
    }

    function showUserResult() {
      for (var item in questionRoot.object) {
        var question = questionRoot.object[item].question;
        if (question.userResult == null) {
          break;
        }
        console.log(question.result, question.userResult);
      }
    }
  }

})();
