/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('TranscriptsCtrl', MainController)

  function MainController($scope, $state, localStorageService, RouteData, $ionicHistory) {

    {
      if (RouteData.transcripts == null) {
        RouteData.transcripts = localStorageService.get("transcripts");
      }
      var questionRoot = RouteData.transcripts.questionRoot;// 接收成绩单

      $scope.bgColor = $('div[nav-bar=cached] .bar.bar-stable').css('background-color');

      $scope.questions = questionRoot.data.object;// 题目列表
      $scope.grade = initGrade();// 初始化评级

      $scope.goAnalysis = goAnalysis;// 去解析
      $scope.reStart = reStart;// 重新开始
      $scope.rest = rest;// 休息一下

      setBackView();
    }

    /**
     * 设置返回视图
     */
    function setBackView() {
      $scope.$on('$ionicView.enter', function (e) {
        var i,
          currentHistoryId = $ionicHistory.currentHistoryId(),
          history = $ionicHistory.viewHistory(),
          stack = history.histories[currentHistoryId].stack;

        for (i = 0; i < stack.length; i += 1) {
          if (stack[i].stateId.indexOf("app.section") == 0) {
            $ionicHistory.backView(stack[i]);
            break;
          }
        }
      });
    }

    function initGrade() {
      var grade = 0;
      for (var item in questionRoot.data.object) {
        var question = questionRoot.data.object[item].question;

        console.log(question.result, question.userResult);
        if (question.result == question.userResult) {
          grade += 1;
        }
      }
      return grade;
    }

    function reStart() {
      $state.go('app.practice');
    }

    function rest() {
      // $state.go('app.home');
      $ionicHistory.goToHistoryRoot($ionicHistory.currentHistoryId());// 通过路由回到根目录避免首页出现返回图标
    }

    function goAnalysis(index) {
      RouteData.analysis = {questionRoot: questionRoot, index: index + 1};
      localStorageService.set("analysis", {questionRoot: questionRoot, index: index + 1});

      $state.go('app.analysis');
    }

    function showUserResult() {
      for (var item in questionRoot.data.object) {
        var question = questionRoot.data.object[item].question;
        if (question.userResult == null) {
        }
        console.log(question.result, question.userResult);
      }
    }

  }

})();
