/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('FeedbackCtrl', MainController);

  function MainController($scope, $state, $httpFactory, warningForm, $ionicHistory) {
    {
      $scope.data = {};
      $scope.tag = {};
      $scope.max = 100;
      $scope.cur = 0;
      $scope.detail = detail;
      $scope.feedbackList = feedbackList;
      $scope.saveOrUpdate = saveOrUpdate;

      initSuggestTag();

      $scope.$on('$ionicView.afterEnter', function () {
        /*添加按钮水波动画*/
        window._bobo.init();
      });
    }

    function initSuggestTag() {
      var suggestTag = window._suggestTag;
      var result = [];
      /* 深度复制 */
      for (var i = 0; i < suggestTag.length; i++) {
        var tag = suggestTag[i];
        var tag2 = {
          "code": tag.code,
          "name": tag.name,
          "firstLine": tag.firstLine
        };
        result.push(tag2);
      }
      $scope.suggestTag = result;
    }

    /*反馈记录*/
    function feedbackList() {
      my.log("反馈记录");
      $state.go("app.feedback_list");
    }

    function detail() {
      $scope.data.suggest = $scope.data.suggest.replace(/\s+/g,"");
      var suggest = $scope.data.suggest;
      if (suggest.length > $scope.max) {
        suggest = suggest.substring(0, $scope.max);
        $scope.data.suggest = suggest;
      }
      $scope.cur = suggest.length;
      my.log("您已经输入" + $scope.cur + "字符");
    }

    /*提交反馈*/
    function saveOrUpdate() {
      var suggest = $scope.data.suggest;
      var selectTag = [];
      var selTagName = "";
      for (var i in $scope.suggestTag) {
        var tag = $scope.suggestTag[i];
        if (tag.select) {
          selectTag += tag.code + ",";
          selTagName += tag.name + ",";
        }
      }
      if (!suggest && !selTagName) {
        warningForm(null, "标签或反馈不能都为空");
        return;
      }
      my.log("suggest is " + suggest);
      my.log("tag contains " + selTagName);
      $httpFactory.setting.userSuggest_1803(suggest, selectTag).then(function (res) {
        if (res.data.result == 0) {
          my.log("提交成功");
          warningForm(null, "提交成功");
          /*反馈设置 清空数据*/
          initSuggestTag();
          $scope.data.suggest = "";
          $ionicHistory.goToHistoryRoot($ionicHistory.currentHistoryId());
        } else {
          my.log("错误：" + res.data.message);
        }
      });
    }
  }

})();
