/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('feedbackListCtrl', MainController);

  function MainController($scope, $state, $httpFactory) {
    {
      $scope.receiptInfo = receiptInfo;
      $scope.feedbackdtl = feedbackdtl;
      $scope.doInfinite = doInfinite;
      $scope.navBack = navBack;

      $scope.tagArr = window._tagArr;
      $scope.hasMore = true;
      $scope.currentPage = 1;//当前页
      $scope.pageSize = 10;//每页条数
      loadDb();
    }

    function loadDb() {
      $httpFactory.setting.suggestQuery_1805($scope.pageSize, $scope.currentPage).then(function (res) {
        if (res.data.result == 0) {
          checkEnd(res.data.totalRec);
          initList(res.data.object);
        } else {
          my.log("错误：" + res.data.message);
        }
      });
    }

    function initList(list) {
      list = preList(list);
      $scope.list = list;
    }

    var prevDate = "";
    /*处理list列表*/
    function preList(list) {
      for (var i = 0; i < list.length; i++) {
        var el = list[i];
        /*处理tag*/
        if (el.tags) {
          var tagArr = el.tags.split(",");
          el.tagArr = tagArr;
        }
        /*处理时间*/
        var curDate = my.data(el.createDate);
        if (curDate != prevDate) {
          el.date = curDate;
          prevDate = curDate;
        }
      }
      return list;
    }

    /*上拉加载*/
    function doInfinite() {
      if (!$scope.hasMore) {
        $scope.$broadcast("scroll.infiniteScrollComplete");// 加载结束
        return;
      }
      $scope.currentPage += 1;
      $httpFactory.setting.suggestQuery_1805($scope.pageSize, $scope.currentPage).then(function (res) {
        if (res.data.result == 0) {
          checkEnd(res.data.totalRec);
          addList(res.data.object);
        } else {
          my.log("错误：" + res.data.message);
        }
      });
    }

    /*检查是否加载完成*/
    function checkEnd(totalRec) {
      if ($scope.currentPage >= totalRec / $scope.pageSize) {
        $scope.hasMore = false;
      }
    }

    function addList(list) {
      list = preList(list);
      $scope.list = $scope.list.concat(list);
      $scope.$broadcast("scroll.infiniteScrollComplete");// 加载结束

    }

    function feedbackdtl(suggest) {
      my.log("反馈详情");
      $state.go('app.feedback_dtl', {suggest: suggest});
    }

    /*收货信息*/
    function receiptInfo() {
      my.log("收货信息");
      $state.go('app.receipt');
    }

    /*返回主页*/
    function navBack() {
      $state.go('app.feedback');
      //$state.go('app.setting');
    }
  }

})();
