/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('ReceiptCtrl', MainController);

  function MainController($scope, $state, $httpFactory, warningForm) {
    {
      loadDb();
      $scope.buttonName = "    ";
      $scope.saveOrUpdate = saveOrUpdate;
      $scope.navBack = navBack;
    }

    /*从数据库获取发货信息*/
    function loadDb() {
      $httpFactory.setting.receiptQuery_1014().then(function(res) {
        if (res.data.result == 0) {
          initReceipt(res.data.object);
        } else {
          my.log("错误：" + res.data.message);
        }
      });
    }

    function initReceipt(receipt) {
      //var receipt = localStorage.getItem("receipt");
      $scope.receipt = receipt;
      //$scope.receipt = JSON.parse(receipt) || {};
      if (receipt == null || receipt.userCode == null) {
        $scope.buttonName = "保存";
      } else {
        $scope.buttonName = "修改";
      }
    }

    /*保存或修改*/
    function saveOrUpdate() {
      var rec = $scope.receipt;
      var mobile = rec.mobile;
      var reg = /^\[0-9]d{11}$/;
      if (!reg.test(mobile)) {
        warningForm(null, "手机号码不正确");
        return;
      }

      $httpFactory.setting.receiptModify_1015(rec.name, rec.mobile, rec.address).then(function(res) {
        if (res.data.result == 0) {
          my.log("保存或修改成功");
          warningForm(null, "保存或修改成功");
        } else {
          my.log("错误：" + res.data.message);
        }
      });
      //localStorage.setItem("receipt", JSON.stringify($scope.receipt));
      $scope.buttonName = "修改";
    }

    /*返回上一页*/
    function navBack() {
      $state.go('app.setting');
    }
  }

})();
