/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('headCtrl', MainController);

  function MainController($scope, $state, $httpFactory, $ionicPlatform, warningForm,$ionicHistory) {
    {
      $scope.bookGold = appv.bookGold;
      $scope.col = 3;//网格行数
      $scope.unlock = unlock;
      $scope.changeHead = changeHead;
      loadDb();
    }

    function loadDb() {
      $httpFactory.exchangeQuery_1902(1).then(function (res) {
        if (res.data.result == 0) {
          initLock(res.data.object);
        } else {
          my.log("错误：" + res.data.message);
        }
      });
      $httpFactory.myGoodsQuery_1907(1).then(function (res) {
        if (res.data.result == 0) {
          initUnLock(res.data.object);
        } else {
          my.log("错误：" + res.data.message);
        }
      });

    }

    function unlock(code) {
      my.log("预解锁 -> " + code);
      $httpFactory.headUnlock_1906(code).then(function (res) {
        my.log(res);
        if (res.data.result == 0) {
          /*解锁成功*/
          warningForm(null, "解锁成功");
          loadDb()
        } else {
          warningForm(null, res.data.message);
        }
      });
    }

    function changeHead(img) {
      var data = {
        content: JSON.stringify({
          icon1: img
        })
      };
      $httpFactory.user.infoChange(data).then(function (res) {
        if (res.data.result == 0) {
          warningForm(null, "更换成功");
          appv.currentUser.icon1 = img;
          selHead();
          $ionicHistory.goBack();
        }
      });
    }

    /*显示已选择的头像*/
    function selHead() {
      var list = $scope.unLockList;
      for (var i = 0; i < list.length; i++) {
        var goods = list[i];
        goods.sel = goods.img == appv.currentUser.icon1;
      }
    }

    function initLock(list) {
      /*先过滤掉我已解锁的*/
      var lockList = [];
      for (var i = 0; i < list.length; i++) {
        var goods = list[i];
        if (!goods.own) {
          lockList.push(goods);
        }
      }
      $scope.lockGrid = list2grid(lockList);
    }

    function initUnLock(list) {
      $scope.unLockGrid = list2grid(list);
      $scope.unLockList = list;
      selHead();
    }

    function list2grid(list) {
      if (list == null) {
        return null;
      }
      var resultGrid = [];
      var row = [];
      var length = list.length;
      var fill = length % $scope.col;
      fill = fill == 0 ? 0 : $scope.col - fill;
      /*填充成col的倍数*/
      for (var i = 0; i < fill; i++) {
        list.push({hide: true});
      }
      length = list.length;
      /*组装成grid*/
      for (var i = 0; i < length; i++) {
        if (i % $scope.col == 0) {
          if (row.length > 0) {
            resultGrid.push(row);
          }
          row = [];
        }
        row.push(list[i]);
        if (i == length - 1) {
          if (row.length > 0) {
            resultGrid.push(row);
          }
        }
      }
      return resultGrid;
    }
  }
})();
