/**
 * Created by Administrator on 2016/8/24 0024.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('UserInfoCtrl', MainController);

  function MainController($scope, $state, $ionicModal, $timeout, $httpFactory, $ionicLoading, localStorageService, $rootScope, $ionicHistory, $ionicPopup) {
    {
      $scope.user = appv.currentUser;
      $scope.change = change;
      $scope.toHead = toHead;
      $scope.close = close;
      $scope.save = save;
      $scope.logout = logout;
      $scope.checkText = checkText;
      $scope.sureLogout = sureLogout;
      $scope.closeLogin = closeLogin;
      $scope.modalData = {
        title: null,
        maxLength: null,
        text: '',
        tip: ''
      };
      $scope.allowText = {
        color: $scope.modalData.text.length <= $scope.modalData.maxLength ? '#0093d8' : 'red'
      }
    }

    function checkText() {
      $scope.modalData.text = $scope.modalData.text.replace(/\s+/g, "");

      if ($scope.modalData.text.length <= $scope.modalData.maxLength) {
        // $scope.modalData.text = $scope.modalData.text.substr(0,$scope.modalData.maxLength);
        $scope.modalDatavalue = $scope.modalData.text;
      } else {
        $scope.modalData.text = $scope.modalDatavalue;
      }
    }

    function logout() {
      //  confirm 确认对话框
      $scope.logoutPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/userInfo/logoutPopup.html',
        scope: $scope
      });
    }

    function sureLogout() {
      localStorageService.clearAll();
      appv.currentUser = null;
      appv.token = null;
      appv.bookGold = null;
      $rootScope.refreshLoginInfo();
      $httpFactory.setToken(null);
      closeLogin();
      $state.go('app.home');
      $ionicLoading.show({template: '退出成功'});
      $rootScope.login();
    }

    function closeLogin() {
      $scope.logoutPopup.close();
      return;
    }

    function toHead() {
      $state.go('app.head');
    }

    function save() {
      if (!$scope.modalData.text || $scope.modalData.text.length <= 0) {
        $ionicLoading.show({template: '请输入有效字符'})
        return;
      }
      if ($scope.modalData.text.length > $scope.modalData.maxLength) {
        $ionicLoading.show({template: "文本过长，请适当减少字数！"});
        return;
      }

      if ($scope.modalData.title == '昵称') {
        var data = {
          content: JSON.stringify({
            nickName: $scope.modalData.text
          })
        };
        $httpFactory.user.infoChange(data).then(function (res) {
          if (res.data.result == 0) {
            $ionicLoading.show({template: res.data.message});
            appv.currentUser.nickName = $scope.modalData.text;
            $scope.user.nickName = $scope.modalData.text;
            close();
          }
        });
      } else if ($scope.modalData.title == '鸡汤') {
        var data = {
          content: JSON.stringify({
            motto: $scope.modalData.text
          })
        };
        $httpFactory.user.infoChange(data).then(function (res) {
          if (res.data.result == 0) {
            $ionicLoading.show({template: res.data.message});
            appv.currentUser.motto = $scope.modalData.text;
            $scope.user.motto = $scope.modalData.text;
            close();
          }
        });
      }
    }

    $ionicModal.fromTemplateUrl('app/userInfo/infoChangeModal/nickNameChange.html', {
      scope: $scope
    }).then(function (modal) {
      $scope.modal = modal;
    });
    function change(type) {
      if (type == _app.infoType_nickName) {
        $scope.modalData.title = '昵称';
        $scope.modalData.maxLength = 10;
        $scope.modalData.text = $scope.user.nickName;
        $scope.modalDatavalue = $scope.user.nickName;
        $scope.modalData.tip = '设置自己的昵称'
      } else if (type == _app.infoType_motto) {
        $scope.modalData.title = '鸡汤';
        $scope.modalData.maxLength = 32;
        $scope.modalData.text = $scope.user.motto;
        $scope.modalDatavalue = $scope.user.motto;
        $scope.modalData.tip = '设置自己的心灵鸡汤'
      }
      $scope.modal.show();
    }

    function close() {
      $scope.modalData.text = null;
      $scope.modal.hide();
    }
  }

})();
