/**
 * Created by Administrator on 2016/9/8 0008.
 */
(function(){
  'use strict'

  angular
    .module('starter')
    .controller('WelcomeAgainCtrl',MainCtrl)

  function MainCtrl($timeout,$state,$scope,$interval,$ionicHistory,RouteData,$httpFactory,localStorageService){
    {
      $scope.welcomeImg = localStorageService.get('welcomeAgainImg')?localStorageService.get('welcomeAgainImg'):'img/welcome/welcomeAgain.jpg';
      getWelcomeImg();
      endTime();
      $scope.toEnd = toEnd;
      $ionicHistory.nextViewOptions({historyRoot: true});
      RouteData.welcome = {after: true};// 已经过
    }

    function toEnd(){
      $interval.cancel($scope.interval);
      $state.go('app.home');
    }

    function endTime() {
      $scope.endTime = 3;
      $scope.interval = $interval(function () {
        $scope.endTime--;
        if ($scope.endTime <= 0) {
          $interval.cancel($scope.interval);
          $state.go('app.home')
        }
      }, 1000);
    }

    function getWelcomeImg(){
      $httpFactory.sys.config('welcome-img').then(function(res){
        if(res.data.result == 0){
          var img = res.data.object[0].value;
          img = adaptation(img);
          localStorageService.set('welcomeAgainImg',img);
        }
      });
    }

    function img2Base64(welome2Img) {

      welome2Img = adaptation(welome2Img);// 设备屏幕适配

      var img = document.createElement('img');
      img.crossOrigin = "Anonymous";// 开启客户端允许跨域
      img.src = welome2Img;
      img.onload = function () {
        var data = getBase64Image(img);
        Storage.set('welcomeAgainImg', data);
        //$scope.welome2Img = data;
      }
    }

    /* 设备屏幕适配 */
    function adaptation(welome2Img){

      var prefix = welome2Img.substr(0,welome2Img.lastIndexOf('/'));

      var width= window.screen.width;
      var height = window.screen.height;
      var result_56 = Math.abs(0.56-(width/height));//  ? 720/1280=0.56
      var result_60 = Math.abs(0.60-(width/height));//  华为pad 601/962=0.62[高度裁剪] 优先使用这个,适当裁剪不至于留白
      var result_66 = Math.abs(0.66-(width/height));//  华为pad 601/962=0.62[高度留白],如:0.65会适配到0.66有留白风险,暂不考虑
      var result_75 = Math.abs(0.75-(width/height));//  ipad 1536/2048=0.75
      var result = Math.min.apply(null, [result_56,result_60,result_66,result_75]);

      console.log('window.screen',width,height,width/height);

      if(result_56 == result){
        console.log('0.56');
        welome2Img = prefix+'/720x1280.jpg';
      }else if(result_60 == result){
        console.log('0.60');
        welome2Img = prefix+'/720x1184.jpg';
      }else if(result_66 == result){
        console.log('0.66');
        welome2Img = prefix+'/960x1440.jpg';
      }else if(result_75 == result){
        console.log('0.75');
        welome2Img = prefix+'/1536x2048.jpg';
      }
      return welome2Img;
    }

    function getBase64Image(img) {
      var canvas = document.createElement("canvas");
      canvas.width = img.width;
      canvas.height = img.height;
      var ctx = canvas.getContext("2d");
      ctx.drawImage(img, 0, 0, img.width, img.height);
      var dataURL = canvas.toDataURL("image/png");
      return dataURL;
      // return dataURL.replace("data:image/png;base64,", "");
    }
  }
})();
