/**
 * Created by Administrator on 2016/8/17 0017.
 */
(function () {
  'use strict';

  angular.module('starter')
    .factory('$httpFactory', mainFactory);

  /**
   *
   * @param $http
   * @param HttpUrl
   * @returns {{kingRank: *, friendsHelp: *}}
   */
  function mainFactory($rootScope, $http, $ionicLoading, AutoDivFactory, localStorageService, $state) {

    /**
     * 服务器地址前缀
     * @type {string}
     */
    var domain_name = _config.domain_name;

    // 设置默认headers
    //$http.defaults.headers.common.client_version = '1.0.0';
    //$http.defaults.headers.common.server_version = '1.0.0';
    $http.defaults.headers.post = {
      'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8'
      //'Content-Type':'application/json'
    };

    /**
     * 设置切面
     */
    $http.defaults.transformRequest = appendTransform($http.defaults.transformRequest, function (value) {
      return value;
    });
    // $http.defaults.transformResponse = appendTransform($http.defaults.transformResponse, function (value) {return value;});

    /**
     * 示例
     * $http.get('/someUrl', config).then(successCallback, errorCallback);
     * $http.post('/someUrl', data, config).then(successCallback, errorCallback);
     */

    var service = {
      setToken: function (token) {
        $http.defaults.headers.common.token = token;
      },
      everyDaySign: function () {
        var url = domain_name + ("/event/everyDaySign");
        return send(url, "POST");
      },
      home: {
        book: function (userId) {
          var url = domain_name + ("/user/bag/" + userId + "/13/1/1");
          // return _response($http.get(url));
          return send(url);
        }
      },
      user: {
        infoChange: function userInfoChange(data) {
          var url = domain_name + "/user/infoModify";
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        },
        redInfo: function () {
          var url = domain_name + "/user/redInfo";
          // //return _response($http.get(url));
          return send(url);
        },
        redInfoRead: function (data) {
          var url = domain_name + "/user/redInfoRead";
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        }
      },
      sys: {
        config: function (key) {
          var url = domain_name + "/sys/config/?key=" + key;
          // return _response($http.get(url));
          return send(url);
        },
      },
      activity: {
        bindInvite: function (code) {
          var url = domain_name + "/invite/" + code;
          // return _response($http.post(url));
          return send(url, "POST");
        },
        list: function (pageSize, currentPage, type) {
          var url = domain_name + "/activity/?pageSize=" + pageSize + "&currentPage=" + currentPage + "&activityType=" + type;
          // return _response($http.get(url));
          return send(url);
        },
        shareGold: function (type) {
          //1qq空间，2微信朋友圈，3微博，4qq，5微信
          var url = domain_name + "invite/share/" + type;
          return send(url, 'POST');
        }
      },
      message: {
        list: function (pageSize, currentPage) {
          var url = domain_name + "/message/list/?pageSize=" + pageSize + "&currentPage=" + currentPage;
          // return _response($http.get(url));
          return send(url);
        },
        read: function (data) {
          var url = domain_name + "/message/read";
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        }
      },
      gold: {
        richList: function (pageSize, currentPage) {
          var url = domain_name + "/gold/richList?pageSize=" + pageSize + "&currentPage=" + currentPage;
          // return _response($http.get(url));
          return send(url);
        }
      },
      section: {
        getPoints: function (sectionCode) {
          var url = domain_name + '/knowPoint/' + sectionCode;
          // return _response($http.get(url));
          return send(url);
        },
        expRead: function (expCode) {
          var url = domain_name + '/knowPoint/expRead/' + expCode;
          // return _response($http.post(url));
          return send(url, "POST");
        }
      },
      practice: {
        getPractices: function (sectionId) {
          var sum = 5;
          var url = domain_name + '/knowPoint/exercise/' + sectionId + '/' + sum;
          // return _response($http.get(url));
          return send(url);
        },
        exercise: function (content) {
          var url = domain_name + '/knowPoint/exercise';
          var data = {content: JSON.stringify(content)};
          //content =  {"knowCode":1,"list":[{"questionCode":10,"result":"33","isTrue":0},{"questionCode":12,"result":"41","isTrue":1}]}
          return send(url, "POST", $.param(data));
        }
      },
      login: {
        normal: function normal(data) {
          var url = domain_name + "/user/login";
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        },
        oneLogin: function oneLogin(data) {
          $http.defaults.headers.common.token = '';
          var url = domain_name + "/user/mobile/oauth";
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        },
        getCode: function (data) {
          var url = domain_name + "/user/mobile/codeSend";
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        },
        thirdLogin: function (data) {
          var url = domain_name + "/user/thirdLogin";
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        },
        oauthLogin: function (data) {
          var url = domain_name + "/user/mobile/oauth";
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        }
      },
      kingRank: function kingRank(userId, pageSize, currentPage) {
        var url = domain_name + ("/acticity/question/kingRank/" + userId + "/?pageSize=" + pageSize + "&currentPage=" + currentPage);
        // return _response($http.get(url));
        return send(url);
      },
      friendsHelp: function friendsHelp(userId, pageSize, currentPage) {
        var url = domain_name + ("/acticity/question/friendsHelp/" + userId + "/?pageSize=" + pageSize + "&currentPage=" + currentPage);
        // return _response($http.get(url));
        return send(url);
      },
      setting: {
        receiptQuery_1014: function () {
          var url = domain_name + "/user/receiptQuery";
          // return _response($http.get(url));
          return send(url);
        },
        receiptModify_1015: function (name, mobile, address) {
          var url = domain_name + "/user/receiptModify";
          var data = {
            content: JSON.stringify({
              "name": name,
              "mobile": mobile,
              "address": address
            })
          };
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        },
        userSuggest_1803: function (suggest, tags) {
          var url = domain_name + "/sys/userSuggest";
          var data = {
            content: JSON.stringify({
              "suggest": suggest,
              "tags": tags
            })
          };
          // return _response($http.post(url, $.param(data)));
          return send(url, "POST", $.param(data));
        },
        suggestQuery_1805: function (pageSize, currentPage) {
          var url = domain_name + "/sys/suggestQuery?pageSize=" + pageSize + "&currentPage=" + currentPage;
          // return _response($http.get(url));
          return send(url);
        }
      },
      softwaveRecommend_1804: function () {
        var url = domain_name + "/sys/softwaveRecommend";
        // return _response($http.get(url));
        return send(url);
      },
      versionQuery_1802: function () {
        var url = domain_name + "/sys/versionQuery";
        // //return _response($http.get(url));
        return send(url);
      },
      /* goodsType 物品类型 0 实物 1虚拟头像 2其他虚拟物品 多个逗号隔开*/
      exchangeQuery_1902: function (goodsType) {
        var url = domain_name + "/goods/exchangeQuery" + "?goodsType=" + goodsType;
        // return _response($http.get(url));
        return send(url);
      },
      headUnlock_1906: function (goodsCode) {
        var url = domain_name + "/goods/headUnlock";
        var data = {
          content: JSON.stringify({
            "goodsCode": goodsCode
          })
        };
        return send(url, "POST", $.param(data));
      },
      /* goodsType 物品类型 0 实物 1虚拟头像 2其他虚拟物品 多个逗号隔开*/
      myGoodsQuery_1907: function (goodsType) {
        var url = domain_name + "/gold/myGoodsQuery" + "?goodsType=" + goodsType;
        // return _response($http.get(url));
        return send(url);
      },
      getSysConfig_1801: function (key) {
        var url = domain_name + "/sysConfig" + "?key=" + key;
        // //return _response($http.get(url));
        return send(url);
      },
      relogin: function (key) {
        var url = domain_name + "/sysConfig" + "?key=" + key;
        // return _response($http.get(url));
        return send(url);
      }
    };
    return service;

    /**************************************************************************************************************/

    function send(url, method, data) {
      !method && (method = "GET");
      var req = {
        method: method,
        url: url,
        data: data
      };

      method == 'GET' && (req.params = data);

      var _http = $http(req);
      _http.catch(httpCatch);
      _http.finally(httpFinally);

      var sign = ~~(Math.random() * 100);// 标记（随机0~99）
      var start = +new Date();
      console.log('request:', sign, method, url, data);
      return _http.then(httpBaseThen);

      function httpBaseThen(response) {

        response.data && console.log('response:', sign, (new Date() - start) / 1000 + 's', response.data.message, response.data.object);
        if (response.data == null || response.data == "") {
          console.log('response:', sign, (new Date() - start) / 1000 + 's', response.data + "(无结果响应)");
          return Promise.reject(response);// 阻断返回
        }

        // 控制token失效
        if (!!response && response.data.message == '请先登录') { // message:"请先登录"
          return oauthLogin(response);
          //return Promise.reject(response);
        } else {

          // 金币奖励
          // var everyDaySignData = {"curRec": 1, "message": "签到成功", "object": {"addGold": 1,"blance":11}, "result": 0, "totalRec": 1};
          // $rootScope.bookGold && ($rootScope.bookGold.blance = $rootScope.bookGold.blance + 1);
          if (response.data.object && response.data.object.blance != null) {

            $rootScope.bookGold && ($rootScope.bookGold.blance = response.data.object.blance);// 更新全局金币($rootScope)
            appv.bookGold && (appv.bookGold.blance = response.data.object.blance);// 更新全局金币(appv)

            // 更新x中金币(bookGoldLocal)
            var bookGoldLocal = localStorageService.get('bookGold');
            bookGoldLocal && (bookGoldLocal.blance = response.data.object.blance);
            bookGoldLocal && (localStorageService.set('bookGold', bookGoldLocal));

            if (response.data.object.addGold > 0) {
              $rootScope.number = response.data.object.addGold;
              if (response.data.message == '签到成功') {
                window.isEveryDaySign = true;
                $rootScope.message = '签到奖励';
              } else {
                $rootScope.message = '';
              }
              AutoDivFactory.open('app/common/gold/gold.html', $rootScope);
            }

          }

          return response;
        }
      }

      function oauthLogin(response) {
        // 失效清理
        appv.currentUser = null;
        window.isEveryDaySign = false;
        $rootScope.refreshLoginInfo();

        var token = appv.token;
        var user = localStorageService.get('currentUser');
        if (token && user) {
          return service.login.oauthLogin({mobile: user.loginName, imei: getImei()}).then(function (response) {
            if (response.data.result == 0) {
              response.data && service.setToken(response.data.object.token); // 刷新Token
              appv.bookGold = response.data.object.bookGold;
              appv.currentUser = response.data.object.user;
              appv.token = response.data.object.token;
              $rootScope.refreshLoginInfo();
              localStorageService.set('token', appv.token);
              localStorageService.set('currentUser', appv.currentUser);
              localStorageService.set('bookGold', appv.bookGold);
              return $http(req);
            } else {
              if (!window.location.hash.match("welcome")) {
                $ionicLoading.show({template: response.data.message});
              }

              window.location.hash.indexOf('welcome') < 0 && $rootScope.login && ($state.go('app.home') && $rootScope.login());// 去登录
              return Promise.reject(response);// 阻断返回
            }
          });
        } else {
          if (!window.location.hash.match("welcome")) {
            $ionicLoading.show({template: response.data.message});
          }
          window.location.hash.indexOf('welcome') < 0 && $rootScope.login && ($state.go('app.home') && $rootScope.login());// 去登录
          return Promise.reject(response);// 阻断返回
        }
      }

      function httpCatch(error) {
        // console.log('response error:', error);
        //
        // var message = '请稍后再试!';
        //
        // if (typeof $cordovaNetwork != 'undefined' && $cordovaNetwork.isOffline()) {
        //   message = '请连接网络!';
        // }
        //
        // $ionicLoading.show({
        //   template: message,
        //   noBackdrop: true
        // });
        //
        // $timeout(function () {
        //   $ionicLoading.hide()
        // }, 1000);
      }

      function httpFinally() {
        // $rootScope.isLoding = false;// 关闭加载圈
        // $rootScope.noLogind = false;
        // $rootScope.$broadcast('scroll.refreshComplete');
      }

    }

    /**
     * 追加切面函数处理
     * @param defaults
     * @param transform
     * @returns {Array.<T>}
     */
    function appendTransform(defaults, transform) {
      // We can't guarantee that the default transformation is an array
      defaults = angular.isArray(defaults) ? defaults : [defaults];

      // Append the new transformation to the defaults
      return defaults.concat(transform);
    }

    function getImei() {
      var imei = "";
      if (_app.isAndroid || _app.isIos) {
        imei = device.uuid;
      }
      return imei;
    }

  }

})();
/**
 * $http 使用详解请见
 * http://devdocs.io/angularjs~1.5/api/ng/service/$http
 *
 * $q(promise) angular承诺的使用
 * http://devdocs.io/angularjs~1.5/api/ng/service/%24q
 **/
