/**
 * Created by Administrator on 2016/8/19 0019.
 */

(function (window) {
  'use strict';

  /**
   * 合并json对象
   * @param jsonbject1
   * @param jsonbject2
   * @returns {{}}
   */
  window.u_mergeJsonObject = function (jsonbject1, jsonbject2) {
    var resultJsonObject = {};
    for (var attr in jsonbject1) {
      resultJsonObject[attr] = jsonbject1[attr];
    }
    for (var attr in jsonbject2) {
      resultJsonObject[attr] = jsonbject2[attr];
    }
    return resultJsonObject;
  };

  /**
   * 深克隆对象
   * @param obj
   * @returns {*}
   */
  window.u_cloneObj = function(obj){
    var str, newobj = obj.constructor === Array ? [] : {};
    if(typeof obj !== 'object'){
      return;
    } else if(window.JSON){
      str = JSON.stringify(obj), //系列化对象
        newobj = JSON.parse(str); //还原
    } else {
      for(var i in obj){
        newobj[i] = typeof obj[i] === 'object' ?
          cloneObj(obj[i]) : obj[i];
      }
    }
    return newobj;
  };

  /* 数字大写转小写 */
  window.u_convert = function(str) {
    var arr = ["一", "二", "三", "四", "五", "六", "七", "八", "九", "十"];
    for (var i = 0; i < arr.length; i++) {
      str = str.replace(new RegExp(arr[i], "g"), (i + 1));
    }
    return str;
    // 使用
    // var str = "一二三三九一";
    // var result = _convert(str);
    // result // 123391
  }

})(window);

