/**
 * Created by Administrator on 2016/8/22 0022.
 */
(function () {
  'use strict';


  angular.module('starter')
    .factory('AppFactory', MainFactory)

  function MainFactory($rootScope, $ionicPlatform, $location) {

    function stateChange() {
      $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {

        if (fromState.name == "") {
          console.time('App state');
          console.time('App page load');
        }

        if (toState.url == '/home') {
          console.time('Home state');
          console.time('Home page load');
        }

        /** 需要登录的路由页面 **/
        var routes = [''];
        if (routes.indexOf(toState.url) > -1) {
          $rootScope.login && $rootScope.login();// 去登录
          event && event.preventDefault();// 阻止模板解析
        }
      });

      $rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
        console.log('from:', fromState.url, 'To:', toState.url, toState.controller, 'toParams:', toParams);
        if (toState.url == '/home') {
          $('.bar.bar-stable').css('background-color', '#279cea');

          var routes = ['/message', '/rich', '/activity', '/recommend_list', '/feedback', '/about', '/userInfo'];
          for (var i = 0; i < routes.length; i++) {
            if (fromState && fromState.url && fromState.url.match(routes[i])) {
              //if (fromState && fromState.url && fromState.url.endsWith && fromState.url.endsWith(routes[i])) {
              document.querySelector('.ion-navicon').click();
              break;
            }
          }
        }
      })
    }

    function app_backButtonAction() {
      //主页面显示退出提示框
      $ionicPlatform.registerBackButtonAction(function (e) {

        e.preventDefault();

        function showConfirm() {
          var confirmPopup = $ionicPopup.confirm({
            title: '<strong>退出应用?</strong>',
            template: '你确定要退出应用吗?',
            okText: '退出',
            cancelText: '取消'
          });

          confirmPopup.then(function (res) {
            if (res) {
              ionic.Platform.exitApp();
            } else {
              // Don't close
            }
          });
        }

        // Is there a page to go back to?
        if ($location.path() == '/home') {
          showConfirm();
        }
        else if (document.querySelector('.popup_div')) {// popup弹窗,禁止返回(手动关闭,避免强制更新被跳过)
          // 风险:隐藏的class(.popup_div)可能会造成全局返回键失效
          return false;
        }
        else if ($rootScope.$viewHistory.backView) {
          console.log('currentView:', $rootScope.$viewHistory.currentView);
          // Go back in history
          $rootScope.$viewHistory.backView.go();
        } else {
          // This is the last page: Show confirmation popup
          showConfirm();
        }

        return false;
      }, 101);
    }

    var service = {
      stateChange: stateChange,
      app_backButtonAction: app_backButtonAction
    }
    return service;
  }
})();
