// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter')
  .run(RunFactory);

function RunFactory($ionicPlatform, AppFactory, ShareFactory, AutoDivFactory, $cordovaStatusbar, $location, $rootScope,$cordovaToast, $cordovaKeyboard,$ionicHistory, $ionicPopup,$ionicLoading,$interval) {

  AppFactory.stateChange();// 路由变化控制
  AppFactory.app_backButtonAction();// app系统返回键控制

  ShareFactory.initShare();// 初始化第三方分享
  AutoDivFactory.init();// 初始化AutoDiv

  $ionicPlatform.ready(function () {
    _app.isAndroid && setTimeout(function () {
      navigator.splashscreen && navigator.splashscreen.hide();// 加载完毕后关闭启动屏幕
    }, 500);

    _app.isIos && navigator.splashscreen && navigator.splashscreen.hide();// 加载完毕后关闭启动屏幕

    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();

      // if (cordova.platformId == 'android') {
      //   StatusBar.backgroundColorByHexString("#333");
      // } else {
      //   $cordovaStatusbar.overlaysWebView(false);
      //   $cordovaStatusbar.style(1);// 样式: 无 : 0, 白色不透明: 1, 黑色半透明: 2, 黑色不透明: 3
      //   StatusBar.styleLightContent();
      //   $cordovaStatusbar.styleColor('black');
      // }
    }

    !_app.isWeb && window.screen.lockOrientation("portrait");
    !_app.isWeb && umengService.init({"args": "init"});// 初始化友盟
    listenBackButton();
  });

  function  listenBackButton(){
    //物理返回按钮控制&双击退出应用
    $ionicPlatform.registerBackButtonAction(function (e) {
      //判断处于哪个页面时双击退出
      if ($location.path() == '/app/welcome' || $location.path() == '/app/home' || $location.path() == '/app/welcomeAgain') {
        if ($rootScope.backButtonPressedOnceToExit) {
          ionic.Platform.exitApp();
        } else {
          $rootScope.backButtonPressedOnceToExit = true;
          $cordovaToast.showShortBottom('再按一次退出系统');
          setTimeout(function () {
            $rootScope.backButtonPressedOnceToExit = false;
          }, 2000);
        }
      }else if ($ionicHistory.viewHistory().backView) {
        $ionicHistory.goBack();
      }
      else {
        $rootScope.backButtonPressedOnceToExit = true;
        $cordovaToast.showShortBottom('再按一次退出系统');
        setTimeout(function () {
          $rootScope.backButtonPressedOnceToExit = false;
        }, 2000);
      }
      e.preventDefault();
      return false;
    }, 101);
  }

  function listenBackButton2() {
    var exitAppTime = 3;
    $ionicPlatform.registerBackButtonAction(function (e) {
      e.preventDefault();
      function showConfirm() {
        //var confirmPopup = $ionicPopup.confirm({
        //  title: '<strong>退出应用?</strong>',
        //  template: '你确定要退出应用吗?',
        //  okText: '退出',
        //  cancelText: '取消'
        //});
        //confirmPopup.then(function (res) {
        //  if (res) {
        //    ionic.Platform.exitApp();
        //  } else {
        //    // Don't close
        //  }
        //});
        //倒计时

        //按两次返回键退出
        $ionicLoading.show({template:'再按一次退出程序',duration:3000});
        var timeStop = $interval(function () {
          if (exitAppTime <= 0) {
            exitAppTime = 3;
            $interval.cancel(timeStop);
          } else {
            exitAppTime--
          }
        }, 1000);
      }

      // Is there a page to go back to?
      if ($location.path() == '/app/welcome' || $location.path() == '/app/home' || $location.path() == '/app/welcomeAgain') {
        exitAppTime==3 && showConfirm();               //第一次按下返回键,显示提示
        exitAppTime<3 && ionic.Platform.exitApp();     //3秒内重新按下,退出程序
      }
      else if ($ionicHistory.viewHistory().backView) {
        //console.log('currentView:', $ionicHistory.viewHistory().backView);
        // Go back in history
        $ionicHistory.goBack();
      }
      else {
        // This is the last page: Show confirmation popup
        //showConfirm();
      }
      return false;
    }, 101);
  }
}

